// Code generated by go-swagger; DO NOT EDIT.

package admin

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewAdminAddUserBadgesParams creates a new AdminAddUserBadgesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAdminAddUserBadgesParams() *AdminAddUserBadgesParams {
	return &AdminAddUserBadgesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAdminAddUserBadgesParamsWithTimeout creates a new AdminAddUserBadgesParams object
// with the ability to set a timeout on a request.
func NewAdminAddUserBadgesParamsWithTimeout(timeout time.Duration) *AdminAddUserBadgesParams {
	return &AdminAddUserBadgesParams{
		timeout: timeout,
	}
}

// NewAdminAddUserBadgesParamsWithContext creates a new AdminAddUserBadgesParams object
// with the ability to set a context for a request.
func NewAdminAddUserBadgesParamsWithContext(ctx context.Context) *AdminAddUserBadgesParams {
	return &AdminAddUserBadgesParams{
		Context: ctx,
	}
}

// NewAdminAddUserBadgesParamsWithHTTPClient creates a new AdminAddUserBadgesParams object
// with the ability to set a custom HTTPClient for a request.
func NewAdminAddUserBadgesParamsWithHTTPClient(client *http.Client) *AdminAddUserBadgesParams {
	return &AdminAddUserBadgesParams{
		HTTPClient: client,
	}
}

/*
AdminAddUserBadgesParams contains all the parameters to send to the API endpoint

	for the admin add user badges operation.

	Typically these are written to a http.Request.
*/
type AdminAddUserBadgesParams struct {

	// Body.
	Body *models.UserBadgeOption

	/* Username.

	   username of user
	*/
	Username string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the admin add user badges params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AdminAddUserBadgesParams) WithDefaults() *AdminAddUserBadgesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the admin add user badges params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AdminAddUserBadgesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the admin add user badges params
func (o *AdminAddUserBadgesParams) WithTimeout(timeout time.Duration) *AdminAddUserBadgesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the admin add user badges params
func (o *AdminAddUserBadgesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the admin add user badges params
func (o *AdminAddUserBadgesParams) WithContext(ctx context.Context) *AdminAddUserBadgesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the admin add user badges params
func (o *AdminAddUserBadgesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the admin add user badges params
func (o *AdminAddUserBadgesParams) WithHTTPClient(client *http.Client) *AdminAddUserBadgesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the admin add user badges params
func (o *AdminAddUserBadgesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the admin add user badges params
func (o *AdminAddUserBadgesParams) WithBody(body *models.UserBadgeOption) *AdminAddUserBadgesParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the admin add user badges params
func (o *AdminAddUserBadgesParams) SetBody(body *models.UserBadgeOption) {
	o.Body = body
}

// WithUsername adds the username to the admin add user badges params
func (o *AdminAddUserBadgesParams) WithUsername(username string) *AdminAddUserBadgesParams {
	o.SetUsername(username)
	return o
}

// SetUsername adds the username to the admin add user badges params
func (o *AdminAddUserBadgesParams) SetUsername(username string) {
	o.Username = username
}

// WriteToRequest writes these params to a swagger request
func (o *AdminAddUserBadgesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param username
	if err := r.SetPathParam("username", o.Username); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
