// Code generated by go-swagger; DO NOT EDIT.

package admin

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewAdminAdoptRepositoryParams creates a new AdminAdoptRepositoryParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAdminAdoptRepositoryParams() *AdminAdoptRepositoryParams {
	return &AdminAdoptRepositoryParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAdminAdoptRepositoryParamsWithTimeout creates a new AdminAdoptRepositoryParams object
// with the ability to set a timeout on a request.
func NewAdminAdoptRepositoryParamsWithTimeout(timeout time.Duration) *AdminAdoptRepositoryParams {
	return &AdminAdoptRepositoryParams{
		timeout: timeout,
	}
}

// NewAdminAdoptRepositoryParamsWithContext creates a new AdminAdoptRepositoryParams object
// with the ability to set a context for a request.
func NewAdminAdoptRepositoryParamsWithContext(ctx context.Context) *AdminAdoptRepositoryParams {
	return &AdminAdoptRepositoryParams{
		Context: ctx,
	}
}

// NewAdminAdoptRepositoryParamsWithHTTPClient creates a new AdminAdoptRepositoryParams object
// with the ability to set a custom HTTPClient for a request.
func NewAdminAdoptRepositoryParamsWithHTTPClient(client *http.Client) *AdminAdoptRepositoryParams {
	return &AdminAdoptRepositoryParams{
		HTTPClient: client,
	}
}

/*
AdminAdoptRepositoryParams contains all the parameters to send to the API endpoint

	for the admin adopt repository operation.

	Typically these are written to a http.Request.
*/
type AdminAdoptRepositoryParams struct {

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the admin adopt repository params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AdminAdoptRepositoryParams) WithDefaults() *AdminAdoptRepositoryParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the admin adopt repository params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AdminAdoptRepositoryParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the admin adopt repository params
func (o *AdminAdoptRepositoryParams) WithTimeout(timeout time.Duration) *AdminAdoptRepositoryParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the admin adopt repository params
func (o *AdminAdoptRepositoryParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the admin adopt repository params
func (o *AdminAdoptRepositoryParams) WithContext(ctx context.Context) *AdminAdoptRepositoryParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the admin adopt repository params
func (o *AdminAdoptRepositoryParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the admin adopt repository params
func (o *AdminAdoptRepositoryParams) WithHTTPClient(client *http.Client) *AdminAdoptRepositoryParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the admin adopt repository params
func (o *AdminAdoptRepositoryParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOwner adds the owner to the admin adopt repository params
func (o *AdminAdoptRepositoryParams) WithOwner(owner string) *AdminAdoptRepositoryParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the admin adopt repository params
func (o *AdminAdoptRepositoryParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the admin adopt repository params
func (o *AdminAdoptRepositoryParams) WithRepo(repo string) *AdminAdoptRepositoryParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the admin adopt repository params
func (o *AdminAdoptRepositoryParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *AdminAdoptRepositoryParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
