// Code generated by go-swagger; DO NOT EDIT.

package admin

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewAdminEditUserParams creates a new AdminEditUserParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAdminEditUserParams() *AdminEditUserParams {
	return &AdminEditUserParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAdminEditUserParamsWithTimeout creates a new AdminEditUserParams object
// with the ability to set a timeout on a request.
func NewAdminEditUserParamsWithTimeout(timeout time.Duration) *AdminEditUserParams {
	return &AdminEditUserParams{
		timeout: timeout,
	}
}

// NewAdminEditUserParamsWithContext creates a new AdminEditUserParams object
// with the ability to set a context for a request.
func NewAdminEditUserParamsWithContext(ctx context.Context) *AdminEditUserParams {
	return &AdminEditUserParams{
		Context: ctx,
	}
}

// NewAdminEditUserParamsWithHTTPClient creates a new AdminEditUserParams object
// with the ability to set a custom HTTPClient for a request.
func NewAdminEditUserParamsWithHTTPClient(client *http.Client) *AdminEditUserParams {
	return &AdminEditUserParams{
		HTTPClient: client,
	}
}

/*
AdminEditUserParams contains all the parameters to send to the API endpoint

	for the admin edit user operation.

	Typically these are written to a http.Request.
*/
type AdminEditUserParams struct {

	// Body.
	Body *models.EditUserOption

	/* Username.

	   username of user to edit
	*/
	Username string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the admin edit user params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AdminEditUserParams) WithDefaults() *AdminEditUserParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the admin edit user params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AdminEditUserParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the admin edit user params
func (o *AdminEditUserParams) WithTimeout(timeout time.Duration) *AdminEditUserParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the admin edit user params
func (o *AdminEditUserParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the admin edit user params
func (o *AdminEditUserParams) WithContext(ctx context.Context) *AdminEditUserParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the admin edit user params
func (o *AdminEditUserParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the admin edit user params
func (o *AdminEditUserParams) WithHTTPClient(client *http.Client) *AdminEditUserParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the admin edit user params
func (o *AdminEditUserParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the admin edit user params
func (o *AdminEditUserParams) WithBody(body *models.EditUserOption) *AdminEditUserParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the admin edit user params
func (o *AdminEditUserParams) SetBody(body *models.EditUserOption) {
	o.Body = body
}

// WithUsername adds the username to the admin edit user params
func (o *AdminEditUserParams) WithUsername(username string) *AdminEditUserParams {
	o.SetUsername(username)
	return o
}

// SetUsername adds the username to the admin edit user params
func (o *AdminEditUserParams) SetUsername(username string) {
	o.Username = username
}

// WriteToRequest writes these params to a swagger request
func (o *AdminEditUserParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param username
	if err := r.SetPathParam("username", o.Username); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
