// Code generated by go-swagger; DO NOT EDIT.

package admin

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewAdminUnadoptedListParams creates a new AdminUnadoptedListParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAdminUnadoptedListParams() *AdminUnadoptedListParams {
	return &AdminUnadoptedListParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAdminUnadoptedListParamsWithTimeout creates a new AdminUnadoptedListParams object
// with the ability to set a timeout on a request.
func NewAdminUnadoptedListParamsWithTimeout(timeout time.Duration) *AdminUnadoptedListParams {
	return &AdminUnadoptedListParams{
		timeout: timeout,
	}
}

// NewAdminUnadoptedListParamsWithContext creates a new AdminUnadoptedListParams object
// with the ability to set a context for a request.
func NewAdminUnadoptedListParamsWithContext(ctx context.Context) *AdminUnadoptedListParams {
	return &AdminUnadoptedListParams{
		Context: ctx,
	}
}

// NewAdminUnadoptedListParamsWithHTTPClient creates a new AdminUnadoptedListParams object
// with the ability to set a custom HTTPClient for a request.
func NewAdminUnadoptedListParamsWithHTTPClient(client *http.Client) *AdminUnadoptedListParams {
	return &AdminUnadoptedListParams{
		HTTPClient: client,
	}
}

/*
AdminUnadoptedListParams contains all the parameters to send to the API endpoint

	for the admin unadopted list operation.

	Typically these are written to a http.Request.
*/
type AdminUnadoptedListParams struct {

	/* Limit.

	   page size of results
	*/
	Limit *int64

	/* Page.

	   page number of results to return (1-based)
	*/
	Page *int64

	/* Pattern.

	   pattern of repositories to search for
	*/
	Pattern *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the admin unadopted list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AdminUnadoptedListParams) WithDefaults() *AdminUnadoptedListParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the admin unadopted list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AdminUnadoptedListParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the admin unadopted list params
func (o *AdminUnadoptedListParams) WithTimeout(timeout time.Duration) *AdminUnadoptedListParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the admin unadopted list params
func (o *AdminUnadoptedListParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the admin unadopted list params
func (o *AdminUnadoptedListParams) WithContext(ctx context.Context) *AdminUnadoptedListParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the admin unadopted list params
func (o *AdminUnadoptedListParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the admin unadopted list params
func (o *AdminUnadoptedListParams) WithHTTPClient(client *http.Client) *AdminUnadoptedListParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the admin unadopted list params
func (o *AdminUnadoptedListParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLimit adds the limit to the admin unadopted list params
func (o *AdminUnadoptedListParams) WithLimit(limit *int64) *AdminUnadoptedListParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the admin unadopted list params
func (o *AdminUnadoptedListParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithPage adds the page to the admin unadopted list params
func (o *AdminUnadoptedListParams) WithPage(page *int64) *AdminUnadoptedListParams {
	o.SetPage(page)
	return o
}

// SetPage adds the page to the admin unadopted list params
func (o *AdminUnadoptedListParams) SetPage(page *int64) {
	o.Page = page
}

// WithPattern adds the pattern to the admin unadopted list params
func (o *AdminUnadoptedListParams) WithPattern(pattern *string) *AdminUnadoptedListParams {
	o.SetPattern(pattern)
	return o
}

// SetPattern adds the pattern to the admin unadopted list params
func (o *AdminUnadoptedListParams) SetPattern(pattern *string) {
	o.Pattern = pattern
}

// WriteToRequest writes these params to a swagger request
func (o *AdminUnadoptedListParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Page != nil {

		// query param page
		var qrPage int64

		if o.Page != nil {
			qrPage = *o.Page
		}
		qPage := swag.FormatInt64(qrPage)
		if qPage != "" {

			if err := r.SetQueryParam("page", qPage); err != nil {
				return err
			}
		}
	}

	if o.Pattern != nil {

		// query param pattern
		var qrPattern string

		if o.Pattern != nil {
			qrPattern = *o.Pattern
		}
		qPattern := qrPattern
		if qPattern != "" {

			if err := r.SetQueryParam("pattern", qPattern); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
