// Code generated by go-swagger; DO NOT EDIT.

package issue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewIssueAddSubscriptionParams creates a new IssueAddSubscriptionParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIssueAddSubscriptionParams() *IssueAddSubscriptionParams {
	return &IssueAddSubscriptionParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIssueAddSubscriptionParamsWithTimeout creates a new IssueAddSubscriptionParams object
// with the ability to set a timeout on a request.
func NewIssueAddSubscriptionParamsWithTimeout(timeout time.Duration) *IssueAddSubscriptionParams {
	return &IssueAddSubscriptionParams{
		timeout: timeout,
	}
}

// NewIssueAddSubscriptionParamsWithContext creates a new IssueAddSubscriptionParams object
// with the ability to set a context for a request.
func NewIssueAddSubscriptionParamsWithContext(ctx context.Context) *IssueAddSubscriptionParams {
	return &IssueAddSubscriptionParams{
		Context: ctx,
	}
}

// NewIssueAddSubscriptionParamsWithHTTPClient creates a new IssueAddSubscriptionParams object
// with the ability to set a custom HTTPClient for a request.
func NewIssueAddSubscriptionParamsWithHTTPClient(client *http.Client) *IssueAddSubscriptionParams {
	return &IssueAddSubscriptionParams{
		HTTPClient: client,
	}
}

/*
IssueAddSubscriptionParams contains all the parameters to send to the API endpoint

	for the issue add subscription operation.

	Typically these are written to a http.Request.
*/
type IssueAddSubscriptionParams struct {

	/* Index.

	   index of the issue

	   Format: int64
	*/
	Index int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	/* User.

	   user to subscribe
	*/
	User string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the issue add subscription params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueAddSubscriptionParams) WithDefaults() *IssueAddSubscriptionParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the issue add subscription params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueAddSubscriptionParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the issue add subscription params
func (o *IssueAddSubscriptionParams) WithTimeout(timeout time.Duration) *IssueAddSubscriptionParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the issue add subscription params
func (o *IssueAddSubscriptionParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the issue add subscription params
func (o *IssueAddSubscriptionParams) WithContext(ctx context.Context) *IssueAddSubscriptionParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the issue add subscription params
func (o *IssueAddSubscriptionParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the issue add subscription params
func (o *IssueAddSubscriptionParams) WithHTTPClient(client *http.Client) *IssueAddSubscriptionParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the issue add subscription params
func (o *IssueAddSubscriptionParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIndex adds the index to the issue add subscription params
func (o *IssueAddSubscriptionParams) WithIndex(index int64) *IssueAddSubscriptionParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the issue add subscription params
func (o *IssueAddSubscriptionParams) SetIndex(index int64) {
	o.Index = index
}

// WithOwner adds the owner to the issue add subscription params
func (o *IssueAddSubscriptionParams) WithOwner(owner string) *IssueAddSubscriptionParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the issue add subscription params
func (o *IssueAddSubscriptionParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the issue add subscription params
func (o *IssueAddSubscriptionParams) WithRepo(repo string) *IssueAddSubscriptionParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the issue add subscription params
func (o *IssueAddSubscriptionParams) SetRepo(repo string) {
	o.Repo = repo
}

// WithUser adds the user to the issue add subscription params
func (o *IssueAddSubscriptionParams) WithUser(user string) *IssueAddSubscriptionParams {
	o.SetUser(user)
	return o
}

// SetUser adds the user to the issue add subscription params
func (o *IssueAddSubscriptionParams) SetUser(user string) {
	o.User = user
}

// WriteToRequest writes these params to a swagger request
func (o *IssueAddSubscriptionParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.Index)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	// path param user
	if err := r.SetPathParam("user", o.User); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
