// Code generated by go-swagger; DO NOT EDIT.

package issue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewIssueCreateIssueDependenciesParams creates a new IssueCreateIssueDependenciesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIssueCreateIssueDependenciesParams() *IssueCreateIssueDependenciesParams {
	return &IssueCreateIssueDependenciesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIssueCreateIssueDependenciesParamsWithTimeout creates a new IssueCreateIssueDependenciesParams object
// with the ability to set a timeout on a request.
func NewIssueCreateIssueDependenciesParamsWithTimeout(timeout time.Duration) *IssueCreateIssueDependenciesParams {
	return &IssueCreateIssueDependenciesParams{
		timeout: timeout,
	}
}

// NewIssueCreateIssueDependenciesParamsWithContext creates a new IssueCreateIssueDependenciesParams object
// with the ability to set a context for a request.
func NewIssueCreateIssueDependenciesParamsWithContext(ctx context.Context) *IssueCreateIssueDependenciesParams {
	return &IssueCreateIssueDependenciesParams{
		Context: ctx,
	}
}

// NewIssueCreateIssueDependenciesParamsWithHTTPClient creates a new IssueCreateIssueDependenciesParams object
// with the ability to set a custom HTTPClient for a request.
func NewIssueCreateIssueDependenciesParamsWithHTTPClient(client *http.Client) *IssueCreateIssueDependenciesParams {
	return &IssueCreateIssueDependenciesParams{
		HTTPClient: client,
	}
}

/*
IssueCreateIssueDependenciesParams contains all the parameters to send to the API endpoint

	for the issue create issue dependencies operation.

	Typically these are written to a http.Request.
*/
type IssueCreateIssueDependenciesParams struct {

	// Body.
	Body *models.IssueMeta

	/* Index.

	   index of the issue
	*/
	Index string

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the issue create issue dependencies params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueCreateIssueDependenciesParams) WithDefaults() *IssueCreateIssueDependenciesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the issue create issue dependencies params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueCreateIssueDependenciesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the issue create issue dependencies params
func (o *IssueCreateIssueDependenciesParams) WithTimeout(timeout time.Duration) *IssueCreateIssueDependenciesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the issue create issue dependencies params
func (o *IssueCreateIssueDependenciesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the issue create issue dependencies params
func (o *IssueCreateIssueDependenciesParams) WithContext(ctx context.Context) *IssueCreateIssueDependenciesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the issue create issue dependencies params
func (o *IssueCreateIssueDependenciesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the issue create issue dependencies params
func (o *IssueCreateIssueDependenciesParams) WithHTTPClient(client *http.Client) *IssueCreateIssueDependenciesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the issue create issue dependencies params
func (o *IssueCreateIssueDependenciesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the issue create issue dependencies params
func (o *IssueCreateIssueDependenciesParams) WithBody(body *models.IssueMeta) *IssueCreateIssueDependenciesParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the issue create issue dependencies params
func (o *IssueCreateIssueDependenciesParams) SetBody(body *models.IssueMeta) {
	o.Body = body
}

// WithIndex adds the index to the issue create issue dependencies params
func (o *IssueCreateIssueDependenciesParams) WithIndex(index string) *IssueCreateIssueDependenciesParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the issue create issue dependencies params
func (o *IssueCreateIssueDependenciesParams) SetIndex(index string) {
	o.Index = index
}

// WithOwner adds the owner to the issue create issue dependencies params
func (o *IssueCreateIssueDependenciesParams) WithOwner(owner string) *IssueCreateIssueDependenciesParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the issue create issue dependencies params
func (o *IssueCreateIssueDependenciesParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the issue create issue dependencies params
func (o *IssueCreateIssueDependenciesParams) WithRepo(repo string) *IssueCreateIssueDependenciesParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the issue create issue dependencies params
func (o *IssueCreateIssueDependenciesParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *IssueCreateIssueDependenciesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param index
	if err := r.SetPathParam("index", o.Index); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
