// Code generated by go-swagger; DO NOT EDIT.

package issue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewIssueDeleteCommentParams creates a new IssueDeleteCommentParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIssueDeleteCommentParams() *IssueDeleteCommentParams {
	return &IssueDeleteCommentParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIssueDeleteCommentParamsWithTimeout creates a new IssueDeleteCommentParams object
// with the ability to set a timeout on a request.
func NewIssueDeleteCommentParamsWithTimeout(timeout time.Duration) *IssueDeleteCommentParams {
	return &IssueDeleteCommentParams{
		timeout: timeout,
	}
}

// NewIssueDeleteCommentParamsWithContext creates a new IssueDeleteCommentParams object
// with the ability to set a context for a request.
func NewIssueDeleteCommentParamsWithContext(ctx context.Context) *IssueDeleteCommentParams {
	return &IssueDeleteCommentParams{
		Context: ctx,
	}
}

// NewIssueDeleteCommentParamsWithHTTPClient creates a new IssueDeleteCommentParams object
// with the ability to set a custom HTTPClient for a request.
func NewIssueDeleteCommentParamsWithHTTPClient(client *http.Client) *IssueDeleteCommentParams {
	return &IssueDeleteCommentParams{
		HTTPClient: client,
	}
}

/*
IssueDeleteCommentParams contains all the parameters to send to the API endpoint

	for the issue delete comment operation.

	Typically these are written to a http.Request.
*/
type IssueDeleteCommentParams struct {

	/* ID.

	   id of comment to delete

	   Format: int64
	*/
	ID int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the issue delete comment params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueDeleteCommentParams) WithDefaults() *IssueDeleteCommentParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the issue delete comment params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueDeleteCommentParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the issue delete comment params
func (o *IssueDeleteCommentParams) WithTimeout(timeout time.Duration) *IssueDeleteCommentParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the issue delete comment params
func (o *IssueDeleteCommentParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the issue delete comment params
func (o *IssueDeleteCommentParams) WithContext(ctx context.Context) *IssueDeleteCommentParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the issue delete comment params
func (o *IssueDeleteCommentParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the issue delete comment params
func (o *IssueDeleteCommentParams) WithHTTPClient(client *http.Client) *IssueDeleteCommentParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the issue delete comment params
func (o *IssueDeleteCommentParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the issue delete comment params
func (o *IssueDeleteCommentParams) WithID(id int64) *IssueDeleteCommentParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the issue delete comment params
func (o *IssueDeleteCommentParams) SetID(id int64) {
	o.ID = id
}

// WithOwner adds the owner to the issue delete comment params
func (o *IssueDeleteCommentParams) WithOwner(owner string) *IssueDeleteCommentParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the issue delete comment params
func (o *IssueDeleteCommentParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the issue delete comment params
func (o *IssueDeleteCommentParams) WithRepo(repo string) *IssueDeleteCommentParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the issue delete comment params
func (o *IssueDeleteCommentParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *IssueDeleteCommentParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
