// Code generated by go-swagger; DO NOT EDIT.

package issue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewIssueDeleteIssueAttachmentParams creates a new IssueDeleteIssueAttachmentParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIssueDeleteIssueAttachmentParams() *IssueDeleteIssueAttachmentParams {
	return &IssueDeleteIssueAttachmentParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIssueDeleteIssueAttachmentParamsWithTimeout creates a new IssueDeleteIssueAttachmentParams object
// with the ability to set a timeout on a request.
func NewIssueDeleteIssueAttachmentParamsWithTimeout(timeout time.Duration) *IssueDeleteIssueAttachmentParams {
	return &IssueDeleteIssueAttachmentParams{
		timeout: timeout,
	}
}

// NewIssueDeleteIssueAttachmentParamsWithContext creates a new IssueDeleteIssueAttachmentParams object
// with the ability to set a context for a request.
func NewIssueDeleteIssueAttachmentParamsWithContext(ctx context.Context) *IssueDeleteIssueAttachmentParams {
	return &IssueDeleteIssueAttachmentParams{
		Context: ctx,
	}
}

// NewIssueDeleteIssueAttachmentParamsWithHTTPClient creates a new IssueDeleteIssueAttachmentParams object
// with the ability to set a custom HTTPClient for a request.
func NewIssueDeleteIssueAttachmentParamsWithHTTPClient(client *http.Client) *IssueDeleteIssueAttachmentParams {
	return &IssueDeleteIssueAttachmentParams{
		HTTPClient: client,
	}
}

/*
IssueDeleteIssueAttachmentParams contains all the parameters to send to the API endpoint

	for the issue delete issue attachment operation.

	Typically these are written to a http.Request.
*/
type IssueDeleteIssueAttachmentParams struct {

	/* AttachmentID.

	   id of the attachment to delete

	   Format: int64
	*/
	AttachmentID int64

	/* Index.

	   index of the issue

	   Format: int64
	*/
	Index int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the issue delete issue attachment params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueDeleteIssueAttachmentParams) WithDefaults() *IssueDeleteIssueAttachmentParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the issue delete issue attachment params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueDeleteIssueAttachmentParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the issue delete issue attachment params
func (o *IssueDeleteIssueAttachmentParams) WithTimeout(timeout time.Duration) *IssueDeleteIssueAttachmentParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the issue delete issue attachment params
func (o *IssueDeleteIssueAttachmentParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the issue delete issue attachment params
func (o *IssueDeleteIssueAttachmentParams) WithContext(ctx context.Context) *IssueDeleteIssueAttachmentParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the issue delete issue attachment params
func (o *IssueDeleteIssueAttachmentParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the issue delete issue attachment params
func (o *IssueDeleteIssueAttachmentParams) WithHTTPClient(client *http.Client) *IssueDeleteIssueAttachmentParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the issue delete issue attachment params
func (o *IssueDeleteIssueAttachmentParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAttachmentID adds the attachmentID to the issue delete issue attachment params
func (o *IssueDeleteIssueAttachmentParams) WithAttachmentID(attachmentID int64) *IssueDeleteIssueAttachmentParams {
	o.SetAttachmentID(attachmentID)
	return o
}

// SetAttachmentID adds the attachmentId to the issue delete issue attachment params
func (o *IssueDeleteIssueAttachmentParams) SetAttachmentID(attachmentID int64) {
	o.AttachmentID = attachmentID
}

// WithIndex adds the index to the issue delete issue attachment params
func (o *IssueDeleteIssueAttachmentParams) WithIndex(index int64) *IssueDeleteIssueAttachmentParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the issue delete issue attachment params
func (o *IssueDeleteIssueAttachmentParams) SetIndex(index int64) {
	o.Index = index
}

// WithOwner adds the owner to the issue delete issue attachment params
func (o *IssueDeleteIssueAttachmentParams) WithOwner(owner string) *IssueDeleteIssueAttachmentParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the issue delete issue attachment params
func (o *IssueDeleteIssueAttachmentParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the issue delete issue attachment params
func (o *IssueDeleteIssueAttachmentParams) WithRepo(repo string) *IssueDeleteIssueAttachmentParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the issue delete issue attachment params
func (o *IssueDeleteIssueAttachmentParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *IssueDeleteIssueAttachmentParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param attachment_id
	if err := r.SetPathParam("attachment_id", swag.FormatInt64(o.AttachmentID)); err != nil {
		return err
	}

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.Index)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
