// Code generated by go-swagger; DO NOT EDIT.

package issue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewIssueEditIssueDeadlineParams creates a new IssueEditIssueDeadlineParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIssueEditIssueDeadlineParams() *IssueEditIssueDeadlineParams {
	return &IssueEditIssueDeadlineParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIssueEditIssueDeadlineParamsWithTimeout creates a new IssueEditIssueDeadlineParams object
// with the ability to set a timeout on a request.
func NewIssueEditIssueDeadlineParamsWithTimeout(timeout time.Duration) *IssueEditIssueDeadlineParams {
	return &IssueEditIssueDeadlineParams{
		timeout: timeout,
	}
}

// NewIssueEditIssueDeadlineParamsWithContext creates a new IssueEditIssueDeadlineParams object
// with the ability to set a context for a request.
func NewIssueEditIssueDeadlineParamsWithContext(ctx context.Context) *IssueEditIssueDeadlineParams {
	return &IssueEditIssueDeadlineParams{
		Context: ctx,
	}
}

// NewIssueEditIssueDeadlineParamsWithHTTPClient creates a new IssueEditIssueDeadlineParams object
// with the ability to set a custom HTTPClient for a request.
func NewIssueEditIssueDeadlineParamsWithHTTPClient(client *http.Client) *IssueEditIssueDeadlineParams {
	return &IssueEditIssueDeadlineParams{
		HTTPClient: client,
	}
}

/*
IssueEditIssueDeadlineParams contains all the parameters to send to the API endpoint

	for the issue edit issue deadline operation.

	Typically these are written to a http.Request.
*/
type IssueEditIssueDeadlineParams struct {

	// Body.
	Body *models.EditDeadlineOption

	/* Index.

	   index of the issue to create or update a deadline on

	   Format: int64
	*/
	Index int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the issue edit issue deadline params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueEditIssueDeadlineParams) WithDefaults() *IssueEditIssueDeadlineParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the issue edit issue deadline params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueEditIssueDeadlineParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the issue edit issue deadline params
func (o *IssueEditIssueDeadlineParams) WithTimeout(timeout time.Duration) *IssueEditIssueDeadlineParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the issue edit issue deadline params
func (o *IssueEditIssueDeadlineParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the issue edit issue deadline params
func (o *IssueEditIssueDeadlineParams) WithContext(ctx context.Context) *IssueEditIssueDeadlineParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the issue edit issue deadline params
func (o *IssueEditIssueDeadlineParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the issue edit issue deadline params
func (o *IssueEditIssueDeadlineParams) WithHTTPClient(client *http.Client) *IssueEditIssueDeadlineParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the issue edit issue deadline params
func (o *IssueEditIssueDeadlineParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the issue edit issue deadline params
func (o *IssueEditIssueDeadlineParams) WithBody(body *models.EditDeadlineOption) *IssueEditIssueDeadlineParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the issue edit issue deadline params
func (o *IssueEditIssueDeadlineParams) SetBody(body *models.EditDeadlineOption) {
	o.Body = body
}

// WithIndex adds the index to the issue edit issue deadline params
func (o *IssueEditIssueDeadlineParams) WithIndex(index int64) *IssueEditIssueDeadlineParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the issue edit issue deadline params
func (o *IssueEditIssueDeadlineParams) SetIndex(index int64) {
	o.Index = index
}

// WithOwner adds the owner to the issue edit issue deadline params
func (o *IssueEditIssueDeadlineParams) WithOwner(owner string) *IssueEditIssueDeadlineParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the issue edit issue deadline params
func (o *IssueEditIssueDeadlineParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the issue edit issue deadline params
func (o *IssueEditIssueDeadlineParams) WithRepo(repo string) *IssueEditIssueDeadlineParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the issue edit issue deadline params
func (o *IssueEditIssueDeadlineParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *IssueEditIssueDeadlineParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.Index)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
