// Code generated by go-swagger; DO NOT EDIT.

package issue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewIssueListBlocksParams creates a new IssueListBlocksParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIssueListBlocksParams() *IssueListBlocksParams {
	return &IssueListBlocksParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIssueListBlocksParamsWithTimeout creates a new IssueListBlocksParams object
// with the ability to set a timeout on a request.
func NewIssueListBlocksParamsWithTimeout(timeout time.Duration) *IssueListBlocksParams {
	return &IssueListBlocksParams{
		timeout: timeout,
	}
}

// NewIssueListBlocksParamsWithContext creates a new IssueListBlocksParams object
// with the ability to set a context for a request.
func NewIssueListBlocksParamsWithContext(ctx context.Context) *IssueListBlocksParams {
	return &IssueListBlocksParams{
		Context: ctx,
	}
}

// NewIssueListBlocksParamsWithHTTPClient creates a new IssueListBlocksParams object
// with the ability to set a custom HTTPClient for a request.
func NewIssueListBlocksParamsWithHTTPClient(client *http.Client) *IssueListBlocksParams {
	return &IssueListBlocksParams{
		HTTPClient: client,
	}
}

/*
IssueListBlocksParams contains all the parameters to send to the API endpoint

	for the issue list blocks operation.

	Typically these are written to a http.Request.
*/
type IssueListBlocksParams struct {

	/* Index.

	   index of the issue
	*/
	Index string

	/* Limit.

	   page size of results
	*/
	Limit *int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Page.

	   page number of results to return (1-based)
	*/
	Page *int64

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the issue list blocks params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueListBlocksParams) WithDefaults() *IssueListBlocksParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the issue list blocks params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueListBlocksParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the issue list blocks params
func (o *IssueListBlocksParams) WithTimeout(timeout time.Duration) *IssueListBlocksParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the issue list blocks params
func (o *IssueListBlocksParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the issue list blocks params
func (o *IssueListBlocksParams) WithContext(ctx context.Context) *IssueListBlocksParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the issue list blocks params
func (o *IssueListBlocksParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the issue list blocks params
func (o *IssueListBlocksParams) WithHTTPClient(client *http.Client) *IssueListBlocksParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the issue list blocks params
func (o *IssueListBlocksParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIndex adds the index to the issue list blocks params
func (o *IssueListBlocksParams) WithIndex(index string) *IssueListBlocksParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the issue list blocks params
func (o *IssueListBlocksParams) SetIndex(index string) {
	o.Index = index
}

// WithLimit adds the limit to the issue list blocks params
func (o *IssueListBlocksParams) WithLimit(limit *int64) *IssueListBlocksParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the issue list blocks params
func (o *IssueListBlocksParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOwner adds the owner to the issue list blocks params
func (o *IssueListBlocksParams) WithOwner(owner string) *IssueListBlocksParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the issue list blocks params
func (o *IssueListBlocksParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithPage adds the page to the issue list blocks params
func (o *IssueListBlocksParams) WithPage(page *int64) *IssueListBlocksParams {
	o.SetPage(page)
	return o
}

// SetPage adds the page to the issue list blocks params
func (o *IssueListBlocksParams) SetPage(page *int64) {
	o.Page = page
}

// WithRepo adds the repo to the issue list blocks params
func (o *IssueListBlocksParams) WithRepo(repo string) *IssueListBlocksParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the issue list blocks params
func (o *IssueListBlocksParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *IssueListBlocksParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param index
	if err := r.SetPathParam("index", o.Index); err != nil {
		return err
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	if o.Page != nil {

		// query param page
		var qrPage int64

		if o.Page != nil {
			qrPage = *o.Page
		}
		qPage := swag.FormatInt64(qrPage)
		if qPage != "" {

			if err := r.SetQueryParam("page", qPage); err != nil {
				return err
			}
		}
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
