// Code generated by go-swagger; DO NOT EDIT.

package issue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewIssueListIssueCommentAttachmentsParams creates a new IssueListIssueCommentAttachmentsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIssueListIssueCommentAttachmentsParams() *IssueListIssueCommentAttachmentsParams {
	return &IssueListIssueCommentAttachmentsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIssueListIssueCommentAttachmentsParamsWithTimeout creates a new IssueListIssueCommentAttachmentsParams object
// with the ability to set a timeout on a request.
func NewIssueListIssueCommentAttachmentsParamsWithTimeout(timeout time.Duration) *IssueListIssueCommentAttachmentsParams {
	return &IssueListIssueCommentAttachmentsParams{
		timeout: timeout,
	}
}

// NewIssueListIssueCommentAttachmentsParamsWithContext creates a new IssueListIssueCommentAttachmentsParams object
// with the ability to set a context for a request.
func NewIssueListIssueCommentAttachmentsParamsWithContext(ctx context.Context) *IssueListIssueCommentAttachmentsParams {
	return &IssueListIssueCommentAttachmentsParams{
		Context: ctx,
	}
}

// NewIssueListIssueCommentAttachmentsParamsWithHTTPClient creates a new IssueListIssueCommentAttachmentsParams object
// with the ability to set a custom HTTPClient for a request.
func NewIssueListIssueCommentAttachmentsParamsWithHTTPClient(client *http.Client) *IssueListIssueCommentAttachmentsParams {
	return &IssueListIssueCommentAttachmentsParams{
		HTTPClient: client,
	}
}

/*
IssueListIssueCommentAttachmentsParams contains all the parameters to send to the API endpoint

	for the issue list issue comment attachments operation.

	Typically these are written to a http.Request.
*/
type IssueListIssueCommentAttachmentsParams struct {

	/* ID.

	   id of the comment

	   Format: int64
	*/
	ID int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the issue list issue comment attachments params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueListIssueCommentAttachmentsParams) WithDefaults() *IssueListIssueCommentAttachmentsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the issue list issue comment attachments params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueListIssueCommentAttachmentsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the issue list issue comment attachments params
func (o *IssueListIssueCommentAttachmentsParams) WithTimeout(timeout time.Duration) *IssueListIssueCommentAttachmentsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the issue list issue comment attachments params
func (o *IssueListIssueCommentAttachmentsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the issue list issue comment attachments params
func (o *IssueListIssueCommentAttachmentsParams) WithContext(ctx context.Context) *IssueListIssueCommentAttachmentsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the issue list issue comment attachments params
func (o *IssueListIssueCommentAttachmentsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the issue list issue comment attachments params
func (o *IssueListIssueCommentAttachmentsParams) WithHTTPClient(client *http.Client) *IssueListIssueCommentAttachmentsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the issue list issue comment attachments params
func (o *IssueListIssueCommentAttachmentsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the issue list issue comment attachments params
func (o *IssueListIssueCommentAttachmentsParams) WithID(id int64) *IssueListIssueCommentAttachmentsParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the issue list issue comment attachments params
func (o *IssueListIssueCommentAttachmentsParams) SetID(id int64) {
	o.ID = id
}

// WithOwner adds the owner to the issue list issue comment attachments params
func (o *IssueListIssueCommentAttachmentsParams) WithOwner(owner string) *IssueListIssueCommentAttachmentsParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the issue list issue comment attachments params
func (o *IssueListIssueCommentAttachmentsParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the issue list issue comment attachments params
func (o *IssueListIssueCommentAttachmentsParams) WithRepo(repo string) *IssueListIssueCommentAttachmentsParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the issue list issue comment attachments params
func (o *IssueListIssueCommentAttachmentsParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *IssueListIssueCommentAttachmentsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
