// Code generated by go-swagger; DO NOT EDIT.

package issue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewIssueRemoveIssueDependenciesParams creates a new IssueRemoveIssueDependenciesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIssueRemoveIssueDependenciesParams() *IssueRemoveIssueDependenciesParams {
	return &IssueRemoveIssueDependenciesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIssueRemoveIssueDependenciesParamsWithTimeout creates a new IssueRemoveIssueDependenciesParams object
// with the ability to set a timeout on a request.
func NewIssueRemoveIssueDependenciesParamsWithTimeout(timeout time.Duration) *IssueRemoveIssueDependenciesParams {
	return &IssueRemoveIssueDependenciesParams{
		timeout: timeout,
	}
}

// NewIssueRemoveIssueDependenciesParamsWithContext creates a new IssueRemoveIssueDependenciesParams object
// with the ability to set a context for a request.
func NewIssueRemoveIssueDependenciesParamsWithContext(ctx context.Context) *IssueRemoveIssueDependenciesParams {
	return &IssueRemoveIssueDependenciesParams{
		Context: ctx,
	}
}

// NewIssueRemoveIssueDependenciesParamsWithHTTPClient creates a new IssueRemoveIssueDependenciesParams object
// with the ability to set a custom HTTPClient for a request.
func NewIssueRemoveIssueDependenciesParamsWithHTTPClient(client *http.Client) *IssueRemoveIssueDependenciesParams {
	return &IssueRemoveIssueDependenciesParams{
		HTTPClient: client,
	}
}

/*
IssueRemoveIssueDependenciesParams contains all the parameters to send to the API endpoint

	for the issue remove issue dependencies operation.

	Typically these are written to a http.Request.
*/
type IssueRemoveIssueDependenciesParams struct {

	// Body.
	Body *models.IssueMeta

	/* Index.

	   index of the issue
	*/
	Index string

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the issue remove issue dependencies params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueRemoveIssueDependenciesParams) WithDefaults() *IssueRemoveIssueDependenciesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the issue remove issue dependencies params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueRemoveIssueDependenciesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the issue remove issue dependencies params
func (o *IssueRemoveIssueDependenciesParams) WithTimeout(timeout time.Duration) *IssueRemoveIssueDependenciesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the issue remove issue dependencies params
func (o *IssueRemoveIssueDependenciesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the issue remove issue dependencies params
func (o *IssueRemoveIssueDependenciesParams) WithContext(ctx context.Context) *IssueRemoveIssueDependenciesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the issue remove issue dependencies params
func (o *IssueRemoveIssueDependenciesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the issue remove issue dependencies params
func (o *IssueRemoveIssueDependenciesParams) WithHTTPClient(client *http.Client) *IssueRemoveIssueDependenciesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the issue remove issue dependencies params
func (o *IssueRemoveIssueDependenciesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the issue remove issue dependencies params
func (o *IssueRemoveIssueDependenciesParams) WithBody(body *models.IssueMeta) *IssueRemoveIssueDependenciesParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the issue remove issue dependencies params
func (o *IssueRemoveIssueDependenciesParams) SetBody(body *models.IssueMeta) {
	o.Body = body
}

// WithIndex adds the index to the issue remove issue dependencies params
func (o *IssueRemoveIssueDependenciesParams) WithIndex(index string) *IssueRemoveIssueDependenciesParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the issue remove issue dependencies params
func (o *IssueRemoveIssueDependenciesParams) SetIndex(index string) {
	o.Index = index
}

// WithOwner adds the owner to the issue remove issue dependencies params
func (o *IssueRemoveIssueDependenciesParams) WithOwner(owner string) *IssueRemoveIssueDependenciesParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the issue remove issue dependencies params
func (o *IssueRemoveIssueDependenciesParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the issue remove issue dependencies params
func (o *IssueRemoveIssueDependenciesParams) WithRepo(repo string) *IssueRemoveIssueDependenciesParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the issue remove issue dependencies params
func (o *IssueRemoveIssueDependenciesParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *IssueRemoveIssueDependenciesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param index
	if err := r.SetPathParam("index", o.Index); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
