// Code generated by go-swagger; DO NOT EDIT.

package issue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewPinIssueParams creates a new PinIssueParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPinIssueParams() *PinIssueParams {
	return &PinIssueParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPinIssueParamsWithTimeout creates a new PinIssueParams object
// with the ability to set a timeout on a request.
func NewPinIssueParamsWithTimeout(timeout time.Duration) *PinIssueParams {
	return &PinIssueParams{
		timeout: timeout,
	}
}

// NewPinIssueParamsWithContext creates a new PinIssueParams object
// with the ability to set a context for a request.
func NewPinIssueParamsWithContext(ctx context.Context) *PinIssueParams {
	return &PinIssueParams{
		Context: ctx,
	}
}

// NewPinIssueParamsWithHTTPClient creates a new PinIssueParams object
// with the ability to set a custom HTTPClient for a request.
func NewPinIssueParamsWithHTTPClient(client *http.Client) *PinIssueParams {
	return &PinIssueParams{
		HTTPClient: client,
	}
}

/*
PinIssueParams contains all the parameters to send to the API endpoint

	for the pin issue operation.

	Typically these are written to a http.Request.
*/
type PinIssueParams struct {

	/* Index.

	   index of issue to pin

	   Format: int64
	*/
	Index int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the pin issue params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PinIssueParams) WithDefaults() *PinIssueParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the pin issue params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PinIssueParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the pin issue params
func (o *PinIssueParams) WithTimeout(timeout time.Duration) *PinIssueParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the pin issue params
func (o *PinIssueParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the pin issue params
func (o *PinIssueParams) WithContext(ctx context.Context) *PinIssueParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the pin issue params
func (o *PinIssueParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the pin issue params
func (o *PinIssueParams) WithHTTPClient(client *http.Client) *PinIssueParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the pin issue params
func (o *PinIssueParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIndex adds the index to the pin issue params
func (o *PinIssueParams) WithIndex(index int64) *PinIssueParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the pin issue params
func (o *PinIssueParams) SetIndex(index int64) {
	o.Index = index
}

// WithOwner adds the owner to the pin issue params
func (o *PinIssueParams) WithOwner(owner string) *PinIssueParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the pin issue params
func (o *PinIssueParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the pin issue params
func (o *PinIssueParams) WithRepo(repo string) *PinIssueParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the pin issue params
func (o *PinIssueParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *PinIssueParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.Index)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
