// Code generated by go-swagger; DO NOT EDIT.

package miscellaneous

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewRenderMarkupParams creates a new RenderMarkupParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRenderMarkupParams() *RenderMarkupParams {
	return &RenderMarkupParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRenderMarkupParamsWithTimeout creates a new RenderMarkupParams object
// with the ability to set a timeout on a request.
func NewRenderMarkupParamsWithTimeout(timeout time.Duration) *RenderMarkupParams {
	return &RenderMarkupParams{
		timeout: timeout,
	}
}

// NewRenderMarkupParamsWithContext creates a new RenderMarkupParams object
// with the ability to set a context for a request.
func NewRenderMarkupParamsWithContext(ctx context.Context) *RenderMarkupParams {
	return &RenderMarkupParams{
		Context: ctx,
	}
}

// NewRenderMarkupParamsWithHTTPClient creates a new RenderMarkupParams object
// with the ability to set a custom HTTPClient for a request.
func NewRenderMarkupParamsWithHTTPClient(client *http.Client) *RenderMarkupParams {
	return &RenderMarkupParams{
		HTTPClient: client,
	}
}

/*
RenderMarkupParams contains all the parameters to send to the API endpoint

	for the render markup operation.

	Typically these are written to a http.Request.
*/
type RenderMarkupParams struct {

	// Body.
	Body *models.MarkupOption

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the render markup params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RenderMarkupParams) WithDefaults() *RenderMarkupParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the render markup params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RenderMarkupParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the render markup params
func (o *RenderMarkupParams) WithTimeout(timeout time.Duration) *RenderMarkupParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the render markup params
func (o *RenderMarkupParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the render markup params
func (o *RenderMarkupParams) WithContext(ctx context.Context) *RenderMarkupParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the render markup params
func (o *RenderMarkupParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the render markup params
func (o *RenderMarkupParams) WithHTTPClient(client *http.Client) *RenderMarkupParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the render markup params
func (o *RenderMarkupParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the render markup params
func (o *RenderMarkupParams) WithBody(body *models.MarkupOption) *RenderMarkupParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the render markup params
func (o *RenderMarkupParams) SetBody(body *models.MarkupOption) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *RenderMarkupParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
