// Code generated by go-swagger; DO NOT EDIT.

package organization

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewCreateOrgVariableParams creates a new CreateOrgVariableParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateOrgVariableParams() *CreateOrgVariableParams {
	return &CreateOrgVariableParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateOrgVariableParamsWithTimeout creates a new CreateOrgVariableParams object
// with the ability to set a timeout on a request.
func NewCreateOrgVariableParamsWithTimeout(timeout time.Duration) *CreateOrgVariableParams {
	return &CreateOrgVariableParams{
		timeout: timeout,
	}
}

// NewCreateOrgVariableParamsWithContext creates a new CreateOrgVariableParams object
// with the ability to set a context for a request.
func NewCreateOrgVariableParamsWithContext(ctx context.Context) *CreateOrgVariableParams {
	return &CreateOrgVariableParams{
		Context: ctx,
	}
}

// NewCreateOrgVariableParamsWithHTTPClient creates a new CreateOrgVariableParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateOrgVariableParamsWithHTTPClient(client *http.Client) *CreateOrgVariableParams {
	return &CreateOrgVariableParams{
		HTTPClient: client,
	}
}

/*
CreateOrgVariableParams contains all the parameters to send to the API endpoint

	for the create org variable operation.

	Typically these are written to a http.Request.
*/
type CreateOrgVariableParams struct {

	// Body.
	Body *models.CreateVariableOption

	/* Org.

	   name of the organization
	*/
	Org string

	/* Variablename.

	   name of the variable
	*/
	Variablename string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create org variable params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateOrgVariableParams) WithDefaults() *CreateOrgVariableParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create org variable params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateOrgVariableParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create org variable params
func (o *CreateOrgVariableParams) WithTimeout(timeout time.Duration) *CreateOrgVariableParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create org variable params
func (o *CreateOrgVariableParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create org variable params
func (o *CreateOrgVariableParams) WithContext(ctx context.Context) *CreateOrgVariableParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create org variable params
func (o *CreateOrgVariableParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create org variable params
func (o *CreateOrgVariableParams) WithHTTPClient(client *http.Client) *CreateOrgVariableParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create org variable params
func (o *CreateOrgVariableParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the create org variable params
func (o *CreateOrgVariableParams) WithBody(body *models.CreateVariableOption) *CreateOrgVariableParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the create org variable params
func (o *CreateOrgVariableParams) SetBody(body *models.CreateVariableOption) {
	o.Body = body
}

// WithOrg adds the org to the create org variable params
func (o *CreateOrgVariableParams) WithOrg(org string) *CreateOrgVariableParams {
	o.SetOrg(org)
	return o
}

// SetOrg adds the org to the create org variable params
func (o *CreateOrgVariableParams) SetOrg(org string) {
	o.Org = org
}

// WithVariablename adds the variablename to the create org variable params
func (o *CreateOrgVariableParams) WithVariablename(variablename string) *CreateOrgVariableParams {
	o.SetVariablename(variablename)
	return o
}

// SetVariablename adds the variablename to the create org variable params
func (o *CreateOrgVariableParams) SetVariablename(variablename string) {
	o.Variablename = variablename
}

// WriteToRequest writes these params to a swagger request
func (o *CreateOrgVariableParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param org
	if err := r.SetPathParam("org", o.Org); err != nil {
		return err
	}

	// path param variablename
	if err := r.SetPathParam("variablename", o.Variablename); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
