// Code generated by go-swagger; DO NOT EDIT.

package organization

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewOrgCreateHookParams creates a new OrgCreateHookParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewOrgCreateHookParams() *OrgCreateHookParams {
	return &OrgCreateHookParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewOrgCreateHookParamsWithTimeout creates a new OrgCreateHookParams object
// with the ability to set a timeout on a request.
func NewOrgCreateHookParamsWithTimeout(timeout time.Duration) *OrgCreateHookParams {
	return &OrgCreateHookParams{
		timeout: timeout,
	}
}

// NewOrgCreateHookParamsWithContext creates a new OrgCreateHookParams object
// with the ability to set a context for a request.
func NewOrgCreateHookParamsWithContext(ctx context.Context) *OrgCreateHookParams {
	return &OrgCreateHookParams{
		Context: ctx,
	}
}

// NewOrgCreateHookParamsWithHTTPClient creates a new OrgCreateHookParams object
// with the ability to set a custom HTTPClient for a request.
func NewOrgCreateHookParamsWithHTTPClient(client *http.Client) *OrgCreateHookParams {
	return &OrgCreateHookParams{
		HTTPClient: client,
	}
}

/*
OrgCreateHookParams contains all the parameters to send to the API endpoint

	for the org create hook operation.

	Typically these are written to a http.Request.
*/
type OrgCreateHookParams struct {

	// Body.
	Body *models.CreateHookOption

	/* Org.

	   name of the organization
	*/
	Org string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the org create hook params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *OrgCreateHookParams) WithDefaults() *OrgCreateHookParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the org create hook params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *OrgCreateHookParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the org create hook params
func (o *OrgCreateHookParams) WithTimeout(timeout time.Duration) *OrgCreateHookParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the org create hook params
func (o *OrgCreateHookParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the org create hook params
func (o *OrgCreateHookParams) WithContext(ctx context.Context) *OrgCreateHookParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the org create hook params
func (o *OrgCreateHookParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the org create hook params
func (o *OrgCreateHookParams) WithHTTPClient(client *http.Client) *OrgCreateHookParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the org create hook params
func (o *OrgCreateHookParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the org create hook params
func (o *OrgCreateHookParams) WithBody(body *models.CreateHookOption) *OrgCreateHookParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the org create hook params
func (o *OrgCreateHookParams) SetBody(body *models.CreateHookOption) {
	o.Body = body
}

// WithOrg adds the org to the org create hook params
func (o *OrgCreateHookParams) WithOrg(org string) *OrgCreateHookParams {
	o.SetOrg(org)
	return o
}

// SetOrg adds the org to the org create hook params
func (o *OrgCreateHookParams) SetOrg(org string) {
	o.Org = org
}

// WriteToRequest writes these params to a swagger request
func (o *OrgCreateHookParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param org
	if err := r.SetPathParam("org", o.Org); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
