// Code generated by go-swagger; DO NOT EDIT.

package organization

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewOrgDeleteHookParams creates a new OrgDeleteHookParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewOrgDeleteHookParams() *OrgDeleteHookParams {
	return &OrgDeleteHookParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewOrgDeleteHookParamsWithTimeout creates a new OrgDeleteHookParams object
// with the ability to set a timeout on a request.
func NewOrgDeleteHookParamsWithTimeout(timeout time.Duration) *OrgDeleteHookParams {
	return &OrgDeleteHookParams{
		timeout: timeout,
	}
}

// NewOrgDeleteHookParamsWithContext creates a new OrgDeleteHookParams object
// with the ability to set a context for a request.
func NewOrgDeleteHookParamsWithContext(ctx context.Context) *OrgDeleteHookParams {
	return &OrgDeleteHookParams{
		Context: ctx,
	}
}

// NewOrgDeleteHookParamsWithHTTPClient creates a new OrgDeleteHookParams object
// with the ability to set a custom HTTPClient for a request.
func NewOrgDeleteHookParamsWithHTTPClient(client *http.Client) *OrgDeleteHookParams {
	return &OrgDeleteHookParams{
		HTTPClient: client,
	}
}

/*
OrgDeleteHookParams contains all the parameters to send to the API endpoint

	for the org delete hook operation.

	Typically these are written to a http.Request.
*/
type OrgDeleteHookParams struct {

	/* ID.

	   id of the hook to delete

	   Format: int64
	*/
	ID int64

	/* Org.

	   name of the organization
	*/
	Org string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the org delete hook params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *OrgDeleteHookParams) WithDefaults() *OrgDeleteHookParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the org delete hook params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *OrgDeleteHookParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the org delete hook params
func (o *OrgDeleteHookParams) WithTimeout(timeout time.Duration) *OrgDeleteHookParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the org delete hook params
func (o *OrgDeleteHookParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the org delete hook params
func (o *OrgDeleteHookParams) WithContext(ctx context.Context) *OrgDeleteHookParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the org delete hook params
func (o *OrgDeleteHookParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the org delete hook params
func (o *OrgDeleteHookParams) WithHTTPClient(client *http.Client) *OrgDeleteHookParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the org delete hook params
func (o *OrgDeleteHookParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the org delete hook params
func (o *OrgDeleteHookParams) WithID(id int64) *OrgDeleteHookParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the org delete hook params
func (o *OrgDeleteHookParams) SetID(id int64) {
	o.ID = id
}

// WithOrg adds the org to the org delete hook params
func (o *OrgDeleteHookParams) WithOrg(org string) *OrgDeleteHookParams {
	o.SetOrg(org)
	return o
}

// SetOrg adds the org to the org delete hook params
func (o *OrgDeleteHookParams) SetOrg(org string) {
	o.Org = org
}

// WriteToRequest writes these params to a swagger request
func (o *OrgDeleteHookParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	// path param org
	if err := r.SetPathParam("org", o.Org); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
