// Code generated by go-swagger; DO NOT EDIT.

package organization

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewOrgListTeamActivityFeedsParams creates a new OrgListTeamActivityFeedsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewOrgListTeamActivityFeedsParams() *OrgListTeamActivityFeedsParams {
	return &OrgListTeamActivityFeedsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewOrgListTeamActivityFeedsParamsWithTimeout creates a new OrgListTeamActivityFeedsParams object
// with the ability to set a timeout on a request.
func NewOrgListTeamActivityFeedsParamsWithTimeout(timeout time.Duration) *OrgListTeamActivityFeedsParams {
	return &OrgListTeamActivityFeedsParams{
		timeout: timeout,
	}
}

// NewOrgListTeamActivityFeedsParamsWithContext creates a new OrgListTeamActivityFeedsParams object
// with the ability to set a context for a request.
func NewOrgListTeamActivityFeedsParamsWithContext(ctx context.Context) *OrgListTeamActivityFeedsParams {
	return &OrgListTeamActivityFeedsParams{
		Context: ctx,
	}
}

// NewOrgListTeamActivityFeedsParamsWithHTTPClient creates a new OrgListTeamActivityFeedsParams object
// with the ability to set a custom HTTPClient for a request.
func NewOrgListTeamActivityFeedsParamsWithHTTPClient(client *http.Client) *OrgListTeamActivityFeedsParams {
	return &OrgListTeamActivityFeedsParams{
		HTTPClient: client,
	}
}

/*
OrgListTeamActivityFeedsParams contains all the parameters to send to the API endpoint

	for the org list team activity feeds operation.

	Typically these are written to a http.Request.
*/
type OrgListTeamActivityFeedsParams struct {

	/* Date.

	   the date of the activities to be found

	   Format: date
	*/
	Date *strfmt.Date

	/* ID.

	   id of the team

	   Format: int64
	*/
	ID int64

	/* Limit.

	   page size of results
	*/
	Limit *int64

	/* Page.

	   page number of results to return (1-based)
	*/
	Page *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the org list team activity feeds params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *OrgListTeamActivityFeedsParams) WithDefaults() *OrgListTeamActivityFeedsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the org list team activity feeds params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *OrgListTeamActivityFeedsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the org list team activity feeds params
func (o *OrgListTeamActivityFeedsParams) WithTimeout(timeout time.Duration) *OrgListTeamActivityFeedsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the org list team activity feeds params
func (o *OrgListTeamActivityFeedsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the org list team activity feeds params
func (o *OrgListTeamActivityFeedsParams) WithContext(ctx context.Context) *OrgListTeamActivityFeedsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the org list team activity feeds params
func (o *OrgListTeamActivityFeedsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the org list team activity feeds params
func (o *OrgListTeamActivityFeedsParams) WithHTTPClient(client *http.Client) *OrgListTeamActivityFeedsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the org list team activity feeds params
func (o *OrgListTeamActivityFeedsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithDate adds the date to the org list team activity feeds params
func (o *OrgListTeamActivityFeedsParams) WithDate(date *strfmt.Date) *OrgListTeamActivityFeedsParams {
	o.SetDate(date)
	return o
}

// SetDate adds the date to the org list team activity feeds params
func (o *OrgListTeamActivityFeedsParams) SetDate(date *strfmt.Date) {
	o.Date = date
}

// WithID adds the id to the org list team activity feeds params
func (o *OrgListTeamActivityFeedsParams) WithID(id int64) *OrgListTeamActivityFeedsParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the org list team activity feeds params
func (o *OrgListTeamActivityFeedsParams) SetID(id int64) {
	o.ID = id
}

// WithLimit adds the limit to the org list team activity feeds params
func (o *OrgListTeamActivityFeedsParams) WithLimit(limit *int64) *OrgListTeamActivityFeedsParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the org list team activity feeds params
func (o *OrgListTeamActivityFeedsParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithPage adds the page to the org list team activity feeds params
func (o *OrgListTeamActivityFeedsParams) WithPage(page *int64) *OrgListTeamActivityFeedsParams {
	o.SetPage(page)
	return o
}

// SetPage adds the page to the org list team activity feeds params
func (o *OrgListTeamActivityFeedsParams) SetPage(page *int64) {
	o.Page = page
}

// WriteToRequest writes these params to a swagger request
func (o *OrgListTeamActivityFeedsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Date != nil {

		// query param date
		var qrDate strfmt.Date

		if o.Date != nil {
			qrDate = *o.Date
		}
		qDate := qrDate.String()
		if qDate != "" {

			if err := r.SetQueryParam("date", qDate); err != nil {
				return err
			}
		}
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Page != nil {

		// query param page
		var qrPage int64

		if o.Page != nil {
			qrPage = *o.Page
		}
		qPage := swag.FormatInt64(qrPage)
		if qPage != "" {

			if err := r.SetQueryParam("page", qPage); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
