// Code generated by go-swagger; DO NOT EDIT.

package organization

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewUpdateOrgVariableParams creates a new UpdateOrgVariableParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateOrgVariableParams() *UpdateOrgVariableParams {
	return &UpdateOrgVariableParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateOrgVariableParamsWithTimeout creates a new UpdateOrgVariableParams object
// with the ability to set a timeout on a request.
func NewUpdateOrgVariableParamsWithTimeout(timeout time.Duration) *UpdateOrgVariableParams {
	return &UpdateOrgVariableParams{
		timeout: timeout,
	}
}

// NewUpdateOrgVariableParamsWithContext creates a new UpdateOrgVariableParams object
// with the ability to set a context for a request.
func NewUpdateOrgVariableParamsWithContext(ctx context.Context) *UpdateOrgVariableParams {
	return &UpdateOrgVariableParams{
		Context: ctx,
	}
}

// NewUpdateOrgVariableParamsWithHTTPClient creates a new UpdateOrgVariableParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateOrgVariableParamsWithHTTPClient(client *http.Client) *UpdateOrgVariableParams {
	return &UpdateOrgVariableParams{
		HTTPClient: client,
	}
}

/*
UpdateOrgVariableParams contains all the parameters to send to the API endpoint

	for the update org variable operation.

	Typically these are written to a http.Request.
*/
type UpdateOrgVariableParams struct {

	// Body.
	Body *models.UpdateVariableOption

	/* Org.

	   name of the organization
	*/
	Org string

	/* Variablename.

	   name of the variable
	*/
	Variablename string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update org variable params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateOrgVariableParams) WithDefaults() *UpdateOrgVariableParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update org variable params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateOrgVariableParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the update org variable params
func (o *UpdateOrgVariableParams) WithTimeout(timeout time.Duration) *UpdateOrgVariableParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update org variable params
func (o *UpdateOrgVariableParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update org variable params
func (o *UpdateOrgVariableParams) WithContext(ctx context.Context) *UpdateOrgVariableParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update org variable params
func (o *UpdateOrgVariableParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update org variable params
func (o *UpdateOrgVariableParams) WithHTTPClient(client *http.Client) *UpdateOrgVariableParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update org variable params
func (o *UpdateOrgVariableParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the update org variable params
func (o *UpdateOrgVariableParams) WithBody(body *models.UpdateVariableOption) *UpdateOrgVariableParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update org variable params
func (o *UpdateOrgVariableParams) SetBody(body *models.UpdateVariableOption) {
	o.Body = body
}

// WithOrg adds the org to the update org variable params
func (o *UpdateOrgVariableParams) WithOrg(org string) *UpdateOrgVariableParams {
	o.SetOrg(org)
	return o
}

// SetOrg adds the org to the update org variable params
func (o *UpdateOrgVariableParams) SetOrg(org string) {
	o.Org = org
}

// WithVariablename adds the variablename to the update org variable params
func (o *UpdateOrgVariableParams) WithVariablename(variablename string) *UpdateOrgVariableParams {
	o.SetVariablename(variablename)
	return o
}

// SetVariablename adds the variablename to the update org variable params
func (o *UpdateOrgVariableParams) SetVariablename(variablename string) {
	o.Variablename = variablename
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateOrgVariableParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param org
	if err := r.SetPathParam("org", o.Org); err != nil {
		return err
	}

	// path param variablename
	if err := r.SetPathParam("variablename", o.Variablename); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
