// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewCreateRepoVariableParams creates a new CreateRepoVariableParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateRepoVariableParams() *CreateRepoVariableParams {
	return &CreateRepoVariableParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateRepoVariableParamsWithTimeout creates a new CreateRepoVariableParams object
// with the ability to set a timeout on a request.
func NewCreateRepoVariableParamsWithTimeout(timeout time.Duration) *CreateRepoVariableParams {
	return &CreateRepoVariableParams{
		timeout: timeout,
	}
}

// NewCreateRepoVariableParamsWithContext creates a new CreateRepoVariableParams object
// with the ability to set a context for a request.
func NewCreateRepoVariableParamsWithContext(ctx context.Context) *CreateRepoVariableParams {
	return &CreateRepoVariableParams{
		Context: ctx,
	}
}

// NewCreateRepoVariableParamsWithHTTPClient creates a new CreateRepoVariableParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateRepoVariableParamsWithHTTPClient(client *http.Client) *CreateRepoVariableParams {
	return &CreateRepoVariableParams{
		HTTPClient: client,
	}
}

/*
CreateRepoVariableParams contains all the parameters to send to the API endpoint

	for the create repo variable operation.

	Typically these are written to a http.Request.
*/
type CreateRepoVariableParams struct {

	// Body.
	Body *models.CreateVariableOption

	/* Owner.

	   name of the owner
	*/
	Owner string

	/* Repo.

	   name of the repository
	*/
	Repo string

	/* Variablename.

	   name of the variable
	*/
	Variablename string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create repo variable params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateRepoVariableParams) WithDefaults() *CreateRepoVariableParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create repo variable params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateRepoVariableParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create repo variable params
func (o *CreateRepoVariableParams) WithTimeout(timeout time.Duration) *CreateRepoVariableParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create repo variable params
func (o *CreateRepoVariableParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create repo variable params
func (o *CreateRepoVariableParams) WithContext(ctx context.Context) *CreateRepoVariableParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create repo variable params
func (o *CreateRepoVariableParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create repo variable params
func (o *CreateRepoVariableParams) WithHTTPClient(client *http.Client) *CreateRepoVariableParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create repo variable params
func (o *CreateRepoVariableParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the create repo variable params
func (o *CreateRepoVariableParams) WithBody(body *models.CreateVariableOption) *CreateRepoVariableParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the create repo variable params
func (o *CreateRepoVariableParams) SetBody(body *models.CreateVariableOption) {
	o.Body = body
}

// WithOwner adds the owner to the create repo variable params
func (o *CreateRepoVariableParams) WithOwner(owner string) *CreateRepoVariableParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the create repo variable params
func (o *CreateRepoVariableParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the create repo variable params
func (o *CreateRepoVariableParams) WithRepo(repo string) *CreateRepoVariableParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the create repo variable params
func (o *CreateRepoVariableParams) SetRepo(repo string) {
	o.Repo = repo
}

// WithVariablename adds the variablename to the create repo variable params
func (o *CreateRepoVariableParams) WithVariablename(variablename string) *CreateRepoVariableParams {
	o.SetVariablename(variablename)
	return o
}

// SetVariablename adds the variablename to the create repo variable params
func (o *CreateRepoVariableParams) SetVariablename(variablename string) {
	o.Variablename = variablename
}

// WriteToRequest writes these params to a swagger request
func (o *CreateRepoVariableParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	// path param variablename
	if err := r.SetPathParam("variablename", o.Variablename); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
