// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// GetRepoVariableReader is a Reader for the GetRepoVariable structure.
type GetRepoVariableReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetRepoVariableReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetRepoVariableOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewGetRepoVariableBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetRepoVariableNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("[GET /repos/{owner}/{repo}/actions/variables/{variablename}] getRepoVariable", response, response.Code())
	}
}

// NewGetRepoVariableOK creates a GetRepoVariableOK with default headers values
func NewGetRepoVariableOK() *GetRepoVariableOK {
	return &GetRepoVariableOK{}
}

/*
GetRepoVariableOK describes a response with status code 200, with default header values.

ActionVariable
*/
type GetRepoVariableOK struct {
	Payload *models.ActionVariable
}

// IsSuccess returns true when this get repo variable o k response has a 2xx status code
func (o *GetRepoVariableOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get repo variable o k response has a 3xx status code
func (o *GetRepoVariableOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get repo variable o k response has a 4xx status code
func (o *GetRepoVariableOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get repo variable o k response has a 5xx status code
func (o *GetRepoVariableOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get repo variable o k response a status code equal to that given
func (o *GetRepoVariableOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get repo variable o k response
func (o *GetRepoVariableOK) Code() int {
	return 200
}

func (o *GetRepoVariableOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/actions/variables/{variablename}][%d] getRepoVariableOK %s", 200, payload)
}

func (o *GetRepoVariableOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/actions/variables/{variablename}][%d] getRepoVariableOK %s", 200, payload)
}

func (o *GetRepoVariableOK) GetPayload() *models.ActionVariable {
	return o.Payload
}

func (o *GetRepoVariableOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ActionVariable)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRepoVariableBadRequest creates a GetRepoVariableBadRequest with default headers values
func NewGetRepoVariableBadRequest() *GetRepoVariableBadRequest {
	return &GetRepoVariableBadRequest{}
}

/*
GetRepoVariableBadRequest describes a response with status code 400, with default header values.

APIError is error format response
*/
type GetRepoVariableBadRequest struct {
	Message string
	URL     string
}

// IsSuccess returns true when this get repo variable bad request response has a 2xx status code
func (o *GetRepoVariableBadRequest) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get repo variable bad request response has a 3xx status code
func (o *GetRepoVariableBadRequest) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get repo variable bad request response has a 4xx status code
func (o *GetRepoVariableBadRequest) IsClientError() bool {
	return true
}

// IsServerError returns true when this get repo variable bad request response has a 5xx status code
func (o *GetRepoVariableBadRequest) IsServerError() bool {
	return false
}

// IsCode returns true when this get repo variable bad request response a status code equal to that given
func (o *GetRepoVariableBadRequest) IsCode(code int) bool {
	return code == 400
}

// Code gets the status code for the get repo variable bad request response
func (o *GetRepoVariableBadRequest) Code() int {
	return 400
}

func (o *GetRepoVariableBadRequest) Error() string {
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/actions/variables/{variablename}][%d] getRepoVariableBadRequest", 400)
}

func (o *GetRepoVariableBadRequest) String() string {
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/actions/variables/{variablename}][%d] getRepoVariableBadRequest", 400)
}

func (o *GetRepoVariableBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header message
	hdrMessage := response.GetHeader("message")

	if hdrMessage != "" {
		o.Message = hdrMessage
	}

	// hydrates response header url
	hdrURL := response.GetHeader("url")

	if hdrURL != "" {
		o.URL = hdrURL
	}

	return nil
}

// NewGetRepoVariableNotFound creates a GetRepoVariableNotFound with default headers values
func NewGetRepoVariableNotFound() *GetRepoVariableNotFound {
	return &GetRepoVariableNotFound{}
}

/*
GetRepoVariableNotFound describes a response with status code 404, with default header values.

APINotFound is a not found empty response
*/
type GetRepoVariableNotFound struct {
}

// IsSuccess returns true when this get repo variable not found response has a 2xx status code
func (o *GetRepoVariableNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get repo variable not found response has a 3xx status code
func (o *GetRepoVariableNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get repo variable not found response has a 4xx status code
func (o *GetRepoVariableNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this get repo variable not found response has a 5xx status code
func (o *GetRepoVariableNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this get repo variable not found response a status code equal to that given
func (o *GetRepoVariableNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the get repo variable not found response
func (o *GetRepoVariableNotFound) Code() int {
	return 404
}

func (o *GetRepoVariableNotFound) Error() string {
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/actions/variables/{variablename}][%d] getRepoVariableNotFound", 404)
}

func (o *GetRepoVariableNotFound) String() string {
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/actions/variables/{variablename}][%d] getRepoVariableNotFound", 404)
}

func (o *GetRepoVariableNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}
