// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// GetRepoVariablesListReader is a Reader for the GetRepoVariablesList structure.
type GetRepoVariablesListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetRepoVariablesListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetRepoVariablesListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewGetRepoVariablesListBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetRepoVariablesListNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("[GET /repos/{owner}/{repo}/actions/variables] getRepoVariablesList", response, response.Code())
	}
}

// NewGetRepoVariablesListOK creates a GetRepoVariablesListOK with default headers values
func NewGetRepoVariablesListOK() *GetRepoVariablesListOK {
	return &GetRepoVariablesListOK{}
}

/*
GetRepoVariablesListOK describes a response with status code 200, with default header values.

VariableList
*/
type GetRepoVariablesListOK struct {
	Payload []*models.ActionVariable
}

// IsSuccess returns true when this get repo variables list o k response has a 2xx status code
func (o *GetRepoVariablesListOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get repo variables list o k response has a 3xx status code
func (o *GetRepoVariablesListOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get repo variables list o k response has a 4xx status code
func (o *GetRepoVariablesListOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get repo variables list o k response has a 5xx status code
func (o *GetRepoVariablesListOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get repo variables list o k response a status code equal to that given
func (o *GetRepoVariablesListOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get repo variables list o k response
func (o *GetRepoVariablesListOK) Code() int {
	return 200
}

func (o *GetRepoVariablesListOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/actions/variables][%d] getRepoVariablesListOK %s", 200, payload)
}

func (o *GetRepoVariablesListOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/actions/variables][%d] getRepoVariablesListOK %s", 200, payload)
}

func (o *GetRepoVariablesListOK) GetPayload() []*models.ActionVariable {
	return o.Payload
}

func (o *GetRepoVariablesListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRepoVariablesListBadRequest creates a GetRepoVariablesListBadRequest with default headers values
func NewGetRepoVariablesListBadRequest() *GetRepoVariablesListBadRequest {
	return &GetRepoVariablesListBadRequest{}
}

/*
GetRepoVariablesListBadRequest describes a response with status code 400, with default header values.

APIError is error format response
*/
type GetRepoVariablesListBadRequest struct {
	Message string
	URL     string
}

// IsSuccess returns true when this get repo variables list bad request response has a 2xx status code
func (o *GetRepoVariablesListBadRequest) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get repo variables list bad request response has a 3xx status code
func (o *GetRepoVariablesListBadRequest) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get repo variables list bad request response has a 4xx status code
func (o *GetRepoVariablesListBadRequest) IsClientError() bool {
	return true
}

// IsServerError returns true when this get repo variables list bad request response has a 5xx status code
func (o *GetRepoVariablesListBadRequest) IsServerError() bool {
	return false
}

// IsCode returns true when this get repo variables list bad request response a status code equal to that given
func (o *GetRepoVariablesListBadRequest) IsCode(code int) bool {
	return code == 400
}

// Code gets the status code for the get repo variables list bad request response
func (o *GetRepoVariablesListBadRequest) Code() int {
	return 400
}

func (o *GetRepoVariablesListBadRequest) Error() string {
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/actions/variables][%d] getRepoVariablesListBadRequest", 400)
}

func (o *GetRepoVariablesListBadRequest) String() string {
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/actions/variables][%d] getRepoVariablesListBadRequest", 400)
}

func (o *GetRepoVariablesListBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header message
	hdrMessage := response.GetHeader("message")

	if hdrMessage != "" {
		o.Message = hdrMessage
	}

	// hydrates response header url
	hdrURL := response.GetHeader("url")

	if hdrURL != "" {
		o.URL = hdrURL
	}

	return nil
}

// NewGetRepoVariablesListNotFound creates a GetRepoVariablesListNotFound with default headers values
func NewGetRepoVariablesListNotFound() *GetRepoVariablesListNotFound {
	return &GetRepoVariablesListNotFound{}
}

/*
GetRepoVariablesListNotFound describes a response with status code 404, with default header values.

APINotFound is a not found empty response
*/
type GetRepoVariablesListNotFound struct {
}

// IsSuccess returns true when this get repo variables list not found response has a 2xx status code
func (o *GetRepoVariablesListNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get repo variables list not found response has a 3xx status code
func (o *GetRepoVariablesListNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get repo variables list not found response has a 4xx status code
func (o *GetRepoVariablesListNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this get repo variables list not found response has a 5xx status code
func (o *GetRepoVariablesListNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this get repo variables list not found response a status code equal to that given
func (o *GetRepoVariablesListNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the get repo variables list not found response
func (o *GetRepoVariablesListNotFound) Code() int {
	return 404
}

func (o *GetRepoVariablesListNotFound) Error() string {
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/actions/variables][%d] getRepoVariablesListNotFound", 404)
}

func (o *GetRepoVariablesListNotFound) String() string {
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/actions/variables][%d] getRepoVariablesListNotFound", 404)
}

func (o *GetRepoVariablesListNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}
