// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewRepoAddTopicParams creates a new RepoAddTopicParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoAddTopicParams() *RepoAddTopicParams {
	return &RepoAddTopicParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoAddTopicParamsWithTimeout creates a new RepoAddTopicParams object
// with the ability to set a timeout on a request.
func NewRepoAddTopicParamsWithTimeout(timeout time.Duration) *RepoAddTopicParams {
	return &RepoAddTopicParams{
		timeout: timeout,
	}
}

// NewRepoAddTopicParamsWithContext creates a new RepoAddTopicParams object
// with the ability to set a context for a request.
func NewRepoAddTopicParamsWithContext(ctx context.Context) *RepoAddTopicParams {
	return &RepoAddTopicParams{
		Context: ctx,
	}
}

// NewRepoAddTopicParamsWithHTTPClient creates a new RepoAddTopicParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoAddTopicParamsWithHTTPClient(client *http.Client) *RepoAddTopicParams {
	return &RepoAddTopicParams{
		HTTPClient: client,
	}
}

/*
RepoAddTopicParams contains all the parameters to send to the API endpoint

	for the repo add topic operation.

	Typically these are written to a http.Request.
*/
type RepoAddTopicParams struct {

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	/* Topic.

	   name of the topic to add
	*/
	Topic string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo add topic params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoAddTopicParams) WithDefaults() *RepoAddTopicParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo add topic params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoAddTopicParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo add topic params
func (o *RepoAddTopicParams) WithTimeout(timeout time.Duration) *RepoAddTopicParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo add topic params
func (o *RepoAddTopicParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo add topic params
func (o *RepoAddTopicParams) WithContext(ctx context.Context) *RepoAddTopicParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo add topic params
func (o *RepoAddTopicParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo add topic params
func (o *RepoAddTopicParams) WithHTTPClient(client *http.Client) *RepoAddTopicParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo add topic params
func (o *RepoAddTopicParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOwner adds the owner to the repo add topic params
func (o *RepoAddTopicParams) WithOwner(owner string) *RepoAddTopicParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo add topic params
func (o *RepoAddTopicParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo add topic params
func (o *RepoAddTopicParams) WithRepo(repo string) *RepoAddTopicParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo add topic params
func (o *RepoAddTopicParams) SetRepo(repo string) {
	o.Repo = repo
}

// WithTopic adds the topic to the repo add topic params
func (o *RepoAddTopicParams) WithTopic(topic string) *RepoAddTopicParams {
	o.SetTopic(topic)
	return o
}

// SetTopic adds the topic to the repo add topic params
func (o *RepoAddTopicParams) SetTopic(topic string) {
	o.Topic = topic
}

// WriteToRequest writes these params to a swagger request
func (o *RepoAddTopicParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	// path param topic
	if err := r.SetPathParam("topic", o.Topic); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
