// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewRepoCreateWikiPageParams creates a new RepoCreateWikiPageParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoCreateWikiPageParams() *RepoCreateWikiPageParams {
	return &RepoCreateWikiPageParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoCreateWikiPageParamsWithTimeout creates a new RepoCreateWikiPageParams object
// with the ability to set a timeout on a request.
func NewRepoCreateWikiPageParamsWithTimeout(timeout time.Duration) *RepoCreateWikiPageParams {
	return &RepoCreateWikiPageParams{
		timeout: timeout,
	}
}

// NewRepoCreateWikiPageParamsWithContext creates a new RepoCreateWikiPageParams object
// with the ability to set a context for a request.
func NewRepoCreateWikiPageParamsWithContext(ctx context.Context) *RepoCreateWikiPageParams {
	return &RepoCreateWikiPageParams{
		Context: ctx,
	}
}

// NewRepoCreateWikiPageParamsWithHTTPClient creates a new RepoCreateWikiPageParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoCreateWikiPageParamsWithHTTPClient(client *http.Client) *RepoCreateWikiPageParams {
	return &RepoCreateWikiPageParams{
		HTTPClient: client,
	}
}

/*
RepoCreateWikiPageParams contains all the parameters to send to the API endpoint

	for the repo create wiki page operation.

	Typically these are written to a http.Request.
*/
type RepoCreateWikiPageParams struct {

	// Body.
	Body *models.CreateWikiPageOptions

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo create wiki page params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoCreateWikiPageParams) WithDefaults() *RepoCreateWikiPageParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo create wiki page params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoCreateWikiPageParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo create wiki page params
func (o *RepoCreateWikiPageParams) WithTimeout(timeout time.Duration) *RepoCreateWikiPageParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo create wiki page params
func (o *RepoCreateWikiPageParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo create wiki page params
func (o *RepoCreateWikiPageParams) WithContext(ctx context.Context) *RepoCreateWikiPageParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo create wiki page params
func (o *RepoCreateWikiPageParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo create wiki page params
func (o *RepoCreateWikiPageParams) WithHTTPClient(client *http.Client) *RepoCreateWikiPageParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo create wiki page params
func (o *RepoCreateWikiPageParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the repo create wiki page params
func (o *RepoCreateWikiPageParams) WithBody(body *models.CreateWikiPageOptions) *RepoCreateWikiPageParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the repo create wiki page params
func (o *RepoCreateWikiPageParams) SetBody(body *models.CreateWikiPageOptions) {
	o.Body = body
}

// WithOwner adds the owner to the repo create wiki page params
func (o *RepoCreateWikiPageParams) WithOwner(owner string) *RepoCreateWikiPageParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo create wiki page params
func (o *RepoCreateWikiPageParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo create wiki page params
func (o *RepoCreateWikiPageParams) WithRepo(repo string) *RepoCreateWikiPageParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo create wiki page params
func (o *RepoCreateWikiPageParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoCreateWikiPageParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
