// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewRepoDeleteBranchParams creates a new RepoDeleteBranchParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoDeleteBranchParams() *RepoDeleteBranchParams {
	return &RepoDeleteBranchParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoDeleteBranchParamsWithTimeout creates a new RepoDeleteBranchParams object
// with the ability to set a timeout on a request.
func NewRepoDeleteBranchParamsWithTimeout(timeout time.Duration) *RepoDeleteBranchParams {
	return &RepoDeleteBranchParams{
		timeout: timeout,
	}
}

// NewRepoDeleteBranchParamsWithContext creates a new RepoDeleteBranchParams object
// with the ability to set a context for a request.
func NewRepoDeleteBranchParamsWithContext(ctx context.Context) *RepoDeleteBranchParams {
	return &RepoDeleteBranchParams{
		Context: ctx,
	}
}

// NewRepoDeleteBranchParamsWithHTTPClient creates a new RepoDeleteBranchParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoDeleteBranchParamsWithHTTPClient(client *http.Client) *RepoDeleteBranchParams {
	return &RepoDeleteBranchParams{
		HTTPClient: client,
	}
}

/*
RepoDeleteBranchParams contains all the parameters to send to the API endpoint

	for the repo delete branch operation.

	Typically these are written to a http.Request.
*/
type RepoDeleteBranchParams struct {

	/* Branch.

	   branch to delete
	*/
	Branch string

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo delete branch params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoDeleteBranchParams) WithDefaults() *RepoDeleteBranchParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo delete branch params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoDeleteBranchParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo delete branch params
func (o *RepoDeleteBranchParams) WithTimeout(timeout time.Duration) *RepoDeleteBranchParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo delete branch params
func (o *RepoDeleteBranchParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo delete branch params
func (o *RepoDeleteBranchParams) WithContext(ctx context.Context) *RepoDeleteBranchParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo delete branch params
func (o *RepoDeleteBranchParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo delete branch params
func (o *RepoDeleteBranchParams) WithHTTPClient(client *http.Client) *RepoDeleteBranchParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo delete branch params
func (o *RepoDeleteBranchParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBranch adds the branch to the repo delete branch params
func (o *RepoDeleteBranchParams) WithBranch(branch string) *RepoDeleteBranchParams {
	o.SetBranch(branch)
	return o
}

// SetBranch adds the branch to the repo delete branch params
func (o *RepoDeleteBranchParams) SetBranch(branch string) {
	o.Branch = branch
}

// WithOwner adds the owner to the repo delete branch params
func (o *RepoDeleteBranchParams) WithOwner(owner string) *RepoDeleteBranchParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo delete branch params
func (o *RepoDeleteBranchParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo delete branch params
func (o *RepoDeleteBranchParams) WithRepo(repo string) *RepoDeleteBranchParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo delete branch params
func (o *RepoDeleteBranchParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoDeleteBranchParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param branch
	if err := r.SetPathParam("branch", o.Branch); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
