// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewRepoDeleteCollaboratorParams creates a new RepoDeleteCollaboratorParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoDeleteCollaboratorParams() *RepoDeleteCollaboratorParams {
	return &RepoDeleteCollaboratorParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoDeleteCollaboratorParamsWithTimeout creates a new RepoDeleteCollaboratorParams object
// with the ability to set a timeout on a request.
func NewRepoDeleteCollaboratorParamsWithTimeout(timeout time.Duration) *RepoDeleteCollaboratorParams {
	return &RepoDeleteCollaboratorParams{
		timeout: timeout,
	}
}

// NewRepoDeleteCollaboratorParamsWithContext creates a new RepoDeleteCollaboratorParams object
// with the ability to set a context for a request.
func NewRepoDeleteCollaboratorParamsWithContext(ctx context.Context) *RepoDeleteCollaboratorParams {
	return &RepoDeleteCollaboratorParams{
		Context: ctx,
	}
}

// NewRepoDeleteCollaboratorParamsWithHTTPClient creates a new RepoDeleteCollaboratorParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoDeleteCollaboratorParamsWithHTTPClient(client *http.Client) *RepoDeleteCollaboratorParams {
	return &RepoDeleteCollaboratorParams{
		HTTPClient: client,
	}
}

/*
RepoDeleteCollaboratorParams contains all the parameters to send to the API endpoint

	for the repo delete collaborator operation.

	Typically these are written to a http.Request.
*/
type RepoDeleteCollaboratorParams struct {

	/* Collaborator.

	   username of the collaborator to delete
	*/
	Collaborator string

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo delete collaborator params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoDeleteCollaboratorParams) WithDefaults() *RepoDeleteCollaboratorParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo delete collaborator params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoDeleteCollaboratorParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo delete collaborator params
func (o *RepoDeleteCollaboratorParams) WithTimeout(timeout time.Duration) *RepoDeleteCollaboratorParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo delete collaborator params
func (o *RepoDeleteCollaboratorParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo delete collaborator params
func (o *RepoDeleteCollaboratorParams) WithContext(ctx context.Context) *RepoDeleteCollaboratorParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo delete collaborator params
func (o *RepoDeleteCollaboratorParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo delete collaborator params
func (o *RepoDeleteCollaboratorParams) WithHTTPClient(client *http.Client) *RepoDeleteCollaboratorParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo delete collaborator params
func (o *RepoDeleteCollaboratorParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCollaborator adds the collaborator to the repo delete collaborator params
func (o *RepoDeleteCollaboratorParams) WithCollaborator(collaborator string) *RepoDeleteCollaboratorParams {
	o.SetCollaborator(collaborator)
	return o
}

// SetCollaborator adds the collaborator to the repo delete collaborator params
func (o *RepoDeleteCollaboratorParams) SetCollaborator(collaborator string) {
	o.Collaborator = collaborator
}

// WithOwner adds the owner to the repo delete collaborator params
func (o *RepoDeleteCollaboratorParams) WithOwner(owner string) *RepoDeleteCollaboratorParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo delete collaborator params
func (o *RepoDeleteCollaboratorParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo delete collaborator params
func (o *RepoDeleteCollaboratorParams) WithRepo(repo string) *RepoDeleteCollaboratorParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo delete collaborator params
func (o *RepoDeleteCollaboratorParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoDeleteCollaboratorParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param collaborator
	if err := r.SetPathParam("collaborator", o.Collaborator); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
