// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewRepoDeleteGitHookParams creates a new RepoDeleteGitHookParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoDeleteGitHookParams() *RepoDeleteGitHookParams {
	return &RepoDeleteGitHookParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoDeleteGitHookParamsWithTimeout creates a new RepoDeleteGitHookParams object
// with the ability to set a timeout on a request.
func NewRepoDeleteGitHookParamsWithTimeout(timeout time.Duration) *RepoDeleteGitHookParams {
	return &RepoDeleteGitHookParams{
		timeout: timeout,
	}
}

// NewRepoDeleteGitHookParamsWithContext creates a new RepoDeleteGitHookParams object
// with the ability to set a context for a request.
func NewRepoDeleteGitHookParamsWithContext(ctx context.Context) *RepoDeleteGitHookParams {
	return &RepoDeleteGitHookParams{
		Context: ctx,
	}
}

// NewRepoDeleteGitHookParamsWithHTTPClient creates a new RepoDeleteGitHookParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoDeleteGitHookParamsWithHTTPClient(client *http.Client) *RepoDeleteGitHookParams {
	return &RepoDeleteGitHookParams{
		HTTPClient: client,
	}
}

/*
RepoDeleteGitHookParams contains all the parameters to send to the API endpoint

	for the repo delete git hook operation.

	Typically these are written to a http.Request.
*/
type RepoDeleteGitHookParams struct {

	/* ID.

	   id of the hook to get
	*/
	ID string

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo delete git hook params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoDeleteGitHookParams) WithDefaults() *RepoDeleteGitHookParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo delete git hook params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoDeleteGitHookParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo delete git hook params
func (o *RepoDeleteGitHookParams) WithTimeout(timeout time.Duration) *RepoDeleteGitHookParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo delete git hook params
func (o *RepoDeleteGitHookParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo delete git hook params
func (o *RepoDeleteGitHookParams) WithContext(ctx context.Context) *RepoDeleteGitHookParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo delete git hook params
func (o *RepoDeleteGitHookParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo delete git hook params
func (o *RepoDeleteGitHookParams) WithHTTPClient(client *http.Client) *RepoDeleteGitHookParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo delete git hook params
func (o *RepoDeleteGitHookParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the repo delete git hook params
func (o *RepoDeleteGitHookParams) WithID(id string) *RepoDeleteGitHookParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the repo delete git hook params
func (o *RepoDeleteGitHookParams) SetID(id string) {
	o.ID = id
}

// WithOwner adds the owner to the repo delete git hook params
func (o *RepoDeleteGitHookParams) WithOwner(owner string) *RepoDeleteGitHookParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo delete git hook params
func (o *RepoDeleteGitHookParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo delete git hook params
func (o *RepoDeleteGitHookParams) WithRepo(repo string) *RepoDeleteGitHookParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo delete git hook params
func (o *RepoDeleteGitHookParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoDeleteGitHookParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
