// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewRepoDeleteHookParams creates a new RepoDeleteHookParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoDeleteHookParams() *RepoDeleteHookParams {
	return &RepoDeleteHookParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoDeleteHookParamsWithTimeout creates a new RepoDeleteHookParams object
// with the ability to set a timeout on a request.
func NewRepoDeleteHookParamsWithTimeout(timeout time.Duration) *RepoDeleteHookParams {
	return &RepoDeleteHookParams{
		timeout: timeout,
	}
}

// NewRepoDeleteHookParamsWithContext creates a new RepoDeleteHookParams object
// with the ability to set a context for a request.
func NewRepoDeleteHookParamsWithContext(ctx context.Context) *RepoDeleteHookParams {
	return &RepoDeleteHookParams{
		Context: ctx,
	}
}

// NewRepoDeleteHookParamsWithHTTPClient creates a new RepoDeleteHookParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoDeleteHookParamsWithHTTPClient(client *http.Client) *RepoDeleteHookParams {
	return &RepoDeleteHookParams{
		HTTPClient: client,
	}
}

/*
RepoDeleteHookParams contains all the parameters to send to the API endpoint

	for the repo delete hook operation.

	Typically these are written to a http.Request.
*/
type RepoDeleteHookParams struct {

	/* ID.

	   id of the hook to delete

	   Format: int64
	*/
	ID int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo delete hook params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoDeleteHookParams) WithDefaults() *RepoDeleteHookParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo delete hook params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoDeleteHookParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo delete hook params
func (o *RepoDeleteHookParams) WithTimeout(timeout time.Duration) *RepoDeleteHookParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo delete hook params
func (o *RepoDeleteHookParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo delete hook params
func (o *RepoDeleteHookParams) WithContext(ctx context.Context) *RepoDeleteHookParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo delete hook params
func (o *RepoDeleteHookParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo delete hook params
func (o *RepoDeleteHookParams) WithHTTPClient(client *http.Client) *RepoDeleteHookParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo delete hook params
func (o *RepoDeleteHookParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the repo delete hook params
func (o *RepoDeleteHookParams) WithID(id int64) *RepoDeleteHookParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the repo delete hook params
func (o *RepoDeleteHookParams) SetID(id int64) {
	o.ID = id
}

// WithOwner adds the owner to the repo delete hook params
func (o *RepoDeleteHookParams) WithOwner(owner string) *RepoDeleteHookParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo delete hook params
func (o *RepoDeleteHookParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo delete hook params
func (o *RepoDeleteHookParams) WithRepo(repo string) *RepoDeleteHookParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo delete hook params
func (o *RepoDeleteHookParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoDeleteHookParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
