// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewRepoDeletePushMirrorParams creates a new RepoDeletePushMirrorParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoDeletePushMirrorParams() *RepoDeletePushMirrorParams {
	return &RepoDeletePushMirrorParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoDeletePushMirrorParamsWithTimeout creates a new RepoDeletePushMirrorParams object
// with the ability to set a timeout on a request.
func NewRepoDeletePushMirrorParamsWithTimeout(timeout time.Duration) *RepoDeletePushMirrorParams {
	return &RepoDeletePushMirrorParams{
		timeout: timeout,
	}
}

// NewRepoDeletePushMirrorParamsWithContext creates a new RepoDeletePushMirrorParams object
// with the ability to set a context for a request.
func NewRepoDeletePushMirrorParamsWithContext(ctx context.Context) *RepoDeletePushMirrorParams {
	return &RepoDeletePushMirrorParams{
		Context: ctx,
	}
}

// NewRepoDeletePushMirrorParamsWithHTTPClient creates a new RepoDeletePushMirrorParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoDeletePushMirrorParamsWithHTTPClient(client *http.Client) *RepoDeletePushMirrorParams {
	return &RepoDeletePushMirrorParams{
		HTTPClient: client,
	}
}

/*
RepoDeletePushMirrorParams contains all the parameters to send to the API endpoint

	for the repo delete push mirror operation.

	Typically these are written to a http.Request.
*/
type RepoDeletePushMirrorParams struct {

	/* Name.

	   remote name of the pushMirror
	*/
	Name string

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo delete push mirror params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoDeletePushMirrorParams) WithDefaults() *RepoDeletePushMirrorParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo delete push mirror params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoDeletePushMirrorParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo delete push mirror params
func (o *RepoDeletePushMirrorParams) WithTimeout(timeout time.Duration) *RepoDeletePushMirrorParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo delete push mirror params
func (o *RepoDeletePushMirrorParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo delete push mirror params
func (o *RepoDeletePushMirrorParams) WithContext(ctx context.Context) *RepoDeletePushMirrorParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo delete push mirror params
func (o *RepoDeletePushMirrorParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo delete push mirror params
func (o *RepoDeletePushMirrorParams) WithHTTPClient(client *http.Client) *RepoDeletePushMirrorParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo delete push mirror params
func (o *RepoDeletePushMirrorParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithName adds the name to the repo delete push mirror params
func (o *RepoDeletePushMirrorParams) WithName(name string) *RepoDeletePushMirrorParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the repo delete push mirror params
func (o *RepoDeletePushMirrorParams) SetName(name string) {
	o.Name = name
}

// WithOwner adds the owner to the repo delete push mirror params
func (o *RepoDeletePushMirrorParams) WithOwner(owner string) *RepoDeletePushMirrorParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo delete push mirror params
func (o *RepoDeletePushMirrorParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo delete push mirror params
func (o *RepoDeletePushMirrorParams) WithRepo(repo string) *RepoDeletePushMirrorParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo delete push mirror params
func (o *RepoDeletePushMirrorParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoDeletePushMirrorParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param name
	if err := r.SetPathParam("name", o.Name); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
