// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewRepoGetArchiveParams creates a new RepoGetArchiveParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoGetArchiveParams() *RepoGetArchiveParams {
	return &RepoGetArchiveParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoGetArchiveParamsWithTimeout creates a new RepoGetArchiveParams object
// with the ability to set a timeout on a request.
func NewRepoGetArchiveParamsWithTimeout(timeout time.Duration) *RepoGetArchiveParams {
	return &RepoGetArchiveParams{
		timeout: timeout,
	}
}

// NewRepoGetArchiveParamsWithContext creates a new RepoGetArchiveParams object
// with the ability to set a context for a request.
func NewRepoGetArchiveParamsWithContext(ctx context.Context) *RepoGetArchiveParams {
	return &RepoGetArchiveParams{
		Context: ctx,
	}
}

// NewRepoGetArchiveParamsWithHTTPClient creates a new RepoGetArchiveParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoGetArchiveParamsWithHTTPClient(client *http.Client) *RepoGetArchiveParams {
	return &RepoGetArchiveParams{
		HTTPClient: client,
	}
}

/*
RepoGetArchiveParams contains all the parameters to send to the API endpoint

	for the repo get archive operation.

	Typically these are written to a http.Request.
*/
type RepoGetArchiveParams struct {

	/* Archive.

	   the git reference for download with attached archive format (e.g. master.zip)
	*/
	Archive string

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo get archive params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoGetArchiveParams) WithDefaults() *RepoGetArchiveParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo get archive params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoGetArchiveParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo get archive params
func (o *RepoGetArchiveParams) WithTimeout(timeout time.Duration) *RepoGetArchiveParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo get archive params
func (o *RepoGetArchiveParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo get archive params
func (o *RepoGetArchiveParams) WithContext(ctx context.Context) *RepoGetArchiveParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo get archive params
func (o *RepoGetArchiveParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo get archive params
func (o *RepoGetArchiveParams) WithHTTPClient(client *http.Client) *RepoGetArchiveParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo get archive params
func (o *RepoGetArchiveParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithArchive adds the archive to the repo get archive params
func (o *RepoGetArchiveParams) WithArchive(archive string) *RepoGetArchiveParams {
	o.SetArchive(archive)
	return o
}

// SetArchive adds the archive to the repo get archive params
func (o *RepoGetArchiveParams) SetArchive(archive string) {
	o.Archive = archive
}

// WithOwner adds the owner to the repo get archive params
func (o *RepoGetArchiveParams) WithOwner(owner string) *RepoGetArchiveParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo get archive params
func (o *RepoGetArchiveParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo get archive params
func (o *RepoGetArchiveParams) WithRepo(repo string) *RepoGetArchiveParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo get archive params
func (o *RepoGetArchiveParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoGetArchiveParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param archive
	if err := r.SetPathParam("archive", o.Archive); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
