// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewRepoGetContentsParams creates a new RepoGetContentsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoGetContentsParams() *RepoGetContentsParams {
	return &RepoGetContentsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoGetContentsParamsWithTimeout creates a new RepoGetContentsParams object
// with the ability to set a timeout on a request.
func NewRepoGetContentsParamsWithTimeout(timeout time.Duration) *RepoGetContentsParams {
	return &RepoGetContentsParams{
		timeout: timeout,
	}
}

// NewRepoGetContentsParamsWithContext creates a new RepoGetContentsParams object
// with the ability to set a context for a request.
func NewRepoGetContentsParamsWithContext(ctx context.Context) *RepoGetContentsParams {
	return &RepoGetContentsParams{
		Context: ctx,
	}
}

// NewRepoGetContentsParamsWithHTTPClient creates a new RepoGetContentsParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoGetContentsParamsWithHTTPClient(client *http.Client) *RepoGetContentsParams {
	return &RepoGetContentsParams{
		HTTPClient: client,
	}
}

/*
RepoGetContentsParams contains all the parameters to send to the API endpoint

	for the repo get contents operation.

	Typically these are written to a http.Request.
*/
type RepoGetContentsParams struct {

	/* Filepath.

	   path of the dir, file, symlink or submodule in the repo
	*/
	Filepath string

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Ref.

	   The name of the commit/branch/tag. Default the repository’s default branch (usually master)
	*/
	Ref *string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo get contents params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoGetContentsParams) WithDefaults() *RepoGetContentsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo get contents params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoGetContentsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo get contents params
func (o *RepoGetContentsParams) WithTimeout(timeout time.Duration) *RepoGetContentsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo get contents params
func (o *RepoGetContentsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo get contents params
func (o *RepoGetContentsParams) WithContext(ctx context.Context) *RepoGetContentsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo get contents params
func (o *RepoGetContentsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo get contents params
func (o *RepoGetContentsParams) WithHTTPClient(client *http.Client) *RepoGetContentsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo get contents params
func (o *RepoGetContentsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFilepath adds the filepath to the repo get contents params
func (o *RepoGetContentsParams) WithFilepath(filepath string) *RepoGetContentsParams {
	o.SetFilepath(filepath)
	return o
}

// SetFilepath adds the filepath to the repo get contents params
func (o *RepoGetContentsParams) SetFilepath(filepath string) {
	o.Filepath = filepath
}

// WithOwner adds the owner to the repo get contents params
func (o *RepoGetContentsParams) WithOwner(owner string) *RepoGetContentsParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo get contents params
func (o *RepoGetContentsParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRef adds the ref to the repo get contents params
func (o *RepoGetContentsParams) WithRef(ref *string) *RepoGetContentsParams {
	o.SetRef(ref)
	return o
}

// SetRef adds the ref to the repo get contents params
func (o *RepoGetContentsParams) SetRef(ref *string) {
	o.Ref = ref
}

// WithRepo adds the repo to the repo get contents params
func (o *RepoGetContentsParams) WithRepo(repo string) *RepoGetContentsParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo get contents params
func (o *RepoGetContentsParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoGetContentsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param filepath
	if err := r.SetPathParam("filepath", o.Filepath); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	if o.Ref != nil {

		// query param ref
		var qrRef string

		if o.Ref != nil {
			qrRef = *o.Ref
		}
		qRef := qrRef
		if qRef != "" {

			if err := r.SetQueryParam("ref", qRef); err != nil {
				return err
			}
		}
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
