// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewRepoGetParams creates a new RepoGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoGetParams() *RepoGetParams {
	return &RepoGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoGetParamsWithTimeout creates a new RepoGetParams object
// with the ability to set a timeout on a request.
func NewRepoGetParamsWithTimeout(timeout time.Duration) *RepoGetParams {
	return &RepoGetParams{
		timeout: timeout,
	}
}

// NewRepoGetParamsWithContext creates a new RepoGetParams object
// with the ability to set a context for a request.
func NewRepoGetParamsWithContext(ctx context.Context) *RepoGetParams {
	return &RepoGetParams{
		Context: ctx,
	}
}

// NewRepoGetParamsWithHTTPClient creates a new RepoGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoGetParamsWithHTTPClient(client *http.Client) *RepoGetParams {
	return &RepoGetParams{
		HTTPClient: client,
	}
}

/*
RepoGetParams contains all the parameters to send to the API endpoint

	for the repo get operation.

	Typically these are written to a http.Request.
*/
type RepoGetParams struct {

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoGetParams) WithDefaults() *RepoGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo get params
func (o *RepoGetParams) WithTimeout(timeout time.Duration) *RepoGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo get params
func (o *RepoGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo get params
func (o *RepoGetParams) WithContext(ctx context.Context) *RepoGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo get params
func (o *RepoGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo get params
func (o *RepoGetParams) WithHTTPClient(client *http.Client) *RepoGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo get params
func (o *RepoGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOwner adds the owner to the repo get params
func (o *RepoGetParams) WithOwner(owner string) *RepoGetParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo get params
func (o *RepoGetParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo get params
func (o *RepoGetParams) WithRepo(repo string) *RepoGetParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo get params
func (o *RepoGetParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
