// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// RepoListHooksReader is a Reader for the RepoListHooks structure.
type RepoListHooksReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *RepoListHooksReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewRepoListHooksOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 404:
		result := NewRepoListHooksNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("[GET /repos/{owner}/{repo}/hooks] repoListHooks", response, response.Code())
	}
}

// NewRepoListHooksOK creates a RepoListHooksOK with default headers values
func NewRepoListHooksOK() *RepoListHooksOK {
	return &RepoListHooksOK{}
}

/*
RepoListHooksOK describes a response with status code 200, with default header values.

HookList
*/
type RepoListHooksOK struct {
	Payload []*models.Hook
}

// IsSuccess returns true when this repo list hooks o k response has a 2xx status code
func (o *RepoListHooksOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this repo list hooks o k response has a 3xx status code
func (o *RepoListHooksOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this repo list hooks o k response has a 4xx status code
func (o *RepoListHooksOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this repo list hooks o k response has a 5xx status code
func (o *RepoListHooksOK) IsServerError() bool {
	return false
}

// IsCode returns true when this repo list hooks o k response a status code equal to that given
func (o *RepoListHooksOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the repo list hooks o k response
func (o *RepoListHooksOK) Code() int {
	return 200
}

func (o *RepoListHooksOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/hooks][%d] repoListHooksOK %s", 200, payload)
}

func (o *RepoListHooksOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/hooks][%d] repoListHooksOK %s", 200, payload)
}

func (o *RepoListHooksOK) GetPayload() []*models.Hook {
	return o.Payload
}

func (o *RepoListHooksOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewRepoListHooksNotFound creates a RepoListHooksNotFound with default headers values
func NewRepoListHooksNotFound() *RepoListHooksNotFound {
	return &RepoListHooksNotFound{}
}

/*
RepoListHooksNotFound describes a response with status code 404, with default header values.

APINotFound is a not found empty response
*/
type RepoListHooksNotFound struct {
}

// IsSuccess returns true when this repo list hooks not found response has a 2xx status code
func (o *RepoListHooksNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this repo list hooks not found response has a 3xx status code
func (o *RepoListHooksNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this repo list hooks not found response has a 4xx status code
func (o *RepoListHooksNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this repo list hooks not found response has a 5xx status code
func (o *RepoListHooksNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this repo list hooks not found response a status code equal to that given
func (o *RepoListHooksNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the repo list hooks not found response
func (o *RepoListHooksNotFound) Code() int {
	return 404
}

func (o *RepoListHooksNotFound) Error() string {
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/hooks][%d] repoListHooksNotFound", 404)
}

func (o *RepoListHooksNotFound) String() string {
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/hooks][%d] repoListHooksNotFound", 404)
}

func (o *RepoListHooksNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}
