// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// RepoListPinnedIssuesReader is a Reader for the RepoListPinnedIssues structure.
type RepoListPinnedIssuesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *RepoListPinnedIssuesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewRepoListPinnedIssuesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 404:
		result := NewRepoListPinnedIssuesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("[GET /repos/{owner}/{repo}/issues/pinned] repoListPinnedIssues", response, response.Code())
	}
}

// NewRepoListPinnedIssuesOK creates a RepoListPinnedIssuesOK with default headers values
func NewRepoListPinnedIssuesOK() *RepoListPinnedIssuesOK {
	return &RepoListPinnedIssuesOK{}
}

/*
RepoListPinnedIssuesOK describes a response with status code 200, with default header values.

IssueList
*/
type RepoListPinnedIssuesOK struct {
	Payload []*models.Issue
}

// IsSuccess returns true when this repo list pinned issues o k response has a 2xx status code
func (o *RepoListPinnedIssuesOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this repo list pinned issues o k response has a 3xx status code
func (o *RepoListPinnedIssuesOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this repo list pinned issues o k response has a 4xx status code
func (o *RepoListPinnedIssuesOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this repo list pinned issues o k response has a 5xx status code
func (o *RepoListPinnedIssuesOK) IsServerError() bool {
	return false
}

// IsCode returns true when this repo list pinned issues o k response a status code equal to that given
func (o *RepoListPinnedIssuesOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the repo list pinned issues o k response
func (o *RepoListPinnedIssuesOK) Code() int {
	return 200
}

func (o *RepoListPinnedIssuesOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/issues/pinned][%d] repoListPinnedIssuesOK %s", 200, payload)
}

func (o *RepoListPinnedIssuesOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/issues/pinned][%d] repoListPinnedIssuesOK %s", 200, payload)
}

func (o *RepoListPinnedIssuesOK) GetPayload() []*models.Issue {
	return o.Payload
}

func (o *RepoListPinnedIssuesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewRepoListPinnedIssuesNotFound creates a RepoListPinnedIssuesNotFound with default headers values
func NewRepoListPinnedIssuesNotFound() *RepoListPinnedIssuesNotFound {
	return &RepoListPinnedIssuesNotFound{}
}

/*
RepoListPinnedIssuesNotFound describes a response with status code 404, with default header values.

APINotFound is a not found empty response
*/
type RepoListPinnedIssuesNotFound struct {
}

// IsSuccess returns true when this repo list pinned issues not found response has a 2xx status code
func (o *RepoListPinnedIssuesNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this repo list pinned issues not found response has a 3xx status code
func (o *RepoListPinnedIssuesNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this repo list pinned issues not found response has a 4xx status code
func (o *RepoListPinnedIssuesNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this repo list pinned issues not found response has a 5xx status code
func (o *RepoListPinnedIssuesNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this repo list pinned issues not found response a status code equal to that given
func (o *RepoListPinnedIssuesNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the repo list pinned issues not found response
func (o *RepoListPinnedIssuesNotFound) Code() int {
	return 404
}

func (o *RepoListPinnedIssuesNotFound) Error() string {
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/issues/pinned][%d] repoListPinnedIssuesNotFound", 404)
}

func (o *RepoListPinnedIssuesNotFound) String() string {
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/issues/pinned][%d] repoListPinnedIssuesNotFound", 404)
}

func (o *RepoListPinnedIssuesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}
