// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewRepoMirrorSyncParams creates a new RepoMirrorSyncParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoMirrorSyncParams() *RepoMirrorSyncParams {
	return &RepoMirrorSyncParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoMirrorSyncParamsWithTimeout creates a new RepoMirrorSyncParams object
// with the ability to set a timeout on a request.
func NewRepoMirrorSyncParamsWithTimeout(timeout time.Duration) *RepoMirrorSyncParams {
	return &RepoMirrorSyncParams{
		timeout: timeout,
	}
}

// NewRepoMirrorSyncParamsWithContext creates a new RepoMirrorSyncParams object
// with the ability to set a context for a request.
func NewRepoMirrorSyncParamsWithContext(ctx context.Context) *RepoMirrorSyncParams {
	return &RepoMirrorSyncParams{
		Context: ctx,
	}
}

// NewRepoMirrorSyncParamsWithHTTPClient creates a new RepoMirrorSyncParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoMirrorSyncParamsWithHTTPClient(client *http.Client) *RepoMirrorSyncParams {
	return &RepoMirrorSyncParams{
		HTTPClient: client,
	}
}

/*
RepoMirrorSyncParams contains all the parameters to send to the API endpoint

	for the repo mirror sync operation.

	Typically these are written to a http.Request.
*/
type RepoMirrorSyncParams struct {

	/* Owner.

	   owner of the repo to sync
	*/
	Owner string

	/* Repo.

	   name of the repo to sync
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo mirror sync params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoMirrorSyncParams) WithDefaults() *RepoMirrorSyncParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo mirror sync params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoMirrorSyncParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo mirror sync params
func (o *RepoMirrorSyncParams) WithTimeout(timeout time.Duration) *RepoMirrorSyncParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo mirror sync params
func (o *RepoMirrorSyncParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo mirror sync params
func (o *RepoMirrorSyncParams) WithContext(ctx context.Context) *RepoMirrorSyncParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo mirror sync params
func (o *RepoMirrorSyncParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo mirror sync params
func (o *RepoMirrorSyncParams) WithHTTPClient(client *http.Client) *RepoMirrorSyncParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo mirror sync params
func (o *RepoMirrorSyncParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOwner adds the owner to the repo mirror sync params
func (o *RepoMirrorSyncParams) WithOwner(owner string) *RepoMirrorSyncParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo mirror sync params
func (o *RepoMirrorSyncParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo mirror sync params
func (o *RepoMirrorSyncParams) WithRepo(repo string) *RepoMirrorSyncParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo mirror sync params
func (o *RepoMirrorSyncParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoMirrorSyncParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
