// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewRepoPushMirrorSyncParams creates a new RepoPushMirrorSyncParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoPushMirrorSyncParams() *RepoPushMirrorSyncParams {
	return &RepoPushMirrorSyncParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoPushMirrorSyncParamsWithTimeout creates a new RepoPushMirrorSyncParams object
// with the ability to set a timeout on a request.
func NewRepoPushMirrorSyncParamsWithTimeout(timeout time.Duration) *RepoPushMirrorSyncParams {
	return &RepoPushMirrorSyncParams{
		timeout: timeout,
	}
}

// NewRepoPushMirrorSyncParamsWithContext creates a new RepoPushMirrorSyncParams object
// with the ability to set a context for a request.
func NewRepoPushMirrorSyncParamsWithContext(ctx context.Context) *RepoPushMirrorSyncParams {
	return &RepoPushMirrorSyncParams{
		Context: ctx,
	}
}

// NewRepoPushMirrorSyncParamsWithHTTPClient creates a new RepoPushMirrorSyncParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoPushMirrorSyncParamsWithHTTPClient(client *http.Client) *RepoPushMirrorSyncParams {
	return &RepoPushMirrorSyncParams{
		HTTPClient: client,
	}
}

/*
RepoPushMirrorSyncParams contains all the parameters to send to the API endpoint

	for the repo push mirror sync operation.

	Typically these are written to a http.Request.
*/
type RepoPushMirrorSyncParams struct {

	/* Owner.

	   owner of the repo to sync
	*/
	Owner string

	/* Repo.

	   name of the repo to sync
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo push mirror sync params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoPushMirrorSyncParams) WithDefaults() *RepoPushMirrorSyncParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo push mirror sync params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoPushMirrorSyncParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo push mirror sync params
func (o *RepoPushMirrorSyncParams) WithTimeout(timeout time.Duration) *RepoPushMirrorSyncParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo push mirror sync params
func (o *RepoPushMirrorSyncParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo push mirror sync params
func (o *RepoPushMirrorSyncParams) WithContext(ctx context.Context) *RepoPushMirrorSyncParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo push mirror sync params
func (o *RepoPushMirrorSyncParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo push mirror sync params
func (o *RepoPushMirrorSyncParams) WithHTTPClient(client *http.Client) *RepoPushMirrorSyncParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo push mirror sync params
func (o *RepoPushMirrorSyncParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOwner adds the owner to the repo push mirror sync params
func (o *RepoPushMirrorSyncParams) WithOwner(owner string) *RepoPushMirrorSyncParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo push mirror sync params
func (o *RepoPushMirrorSyncParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo push mirror sync params
func (o *RepoPushMirrorSyncParams) WithRepo(repo string) *RepoPushMirrorSyncParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo push mirror sync params
func (o *RepoPushMirrorSyncParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoPushMirrorSyncParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
