// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewRepoUpdateFileParams creates a new RepoUpdateFileParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoUpdateFileParams() *RepoUpdateFileParams {
	return &RepoUpdateFileParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoUpdateFileParamsWithTimeout creates a new RepoUpdateFileParams object
// with the ability to set a timeout on a request.
func NewRepoUpdateFileParamsWithTimeout(timeout time.Duration) *RepoUpdateFileParams {
	return &RepoUpdateFileParams{
		timeout: timeout,
	}
}

// NewRepoUpdateFileParamsWithContext creates a new RepoUpdateFileParams object
// with the ability to set a context for a request.
func NewRepoUpdateFileParamsWithContext(ctx context.Context) *RepoUpdateFileParams {
	return &RepoUpdateFileParams{
		Context: ctx,
	}
}

// NewRepoUpdateFileParamsWithHTTPClient creates a new RepoUpdateFileParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoUpdateFileParamsWithHTTPClient(client *http.Client) *RepoUpdateFileParams {
	return &RepoUpdateFileParams{
		HTTPClient: client,
	}
}

/*
RepoUpdateFileParams contains all the parameters to send to the API endpoint

	for the repo update file operation.

	Typically these are written to a http.Request.
*/
type RepoUpdateFileParams struct {

	// Body.
	Body *models.UpdateFileOptions

	/* Filepath.

	   path of the file to update
	*/
	Filepath string

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo update file params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoUpdateFileParams) WithDefaults() *RepoUpdateFileParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo update file params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoUpdateFileParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo update file params
func (o *RepoUpdateFileParams) WithTimeout(timeout time.Duration) *RepoUpdateFileParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo update file params
func (o *RepoUpdateFileParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo update file params
func (o *RepoUpdateFileParams) WithContext(ctx context.Context) *RepoUpdateFileParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo update file params
func (o *RepoUpdateFileParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo update file params
func (o *RepoUpdateFileParams) WithHTTPClient(client *http.Client) *RepoUpdateFileParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo update file params
func (o *RepoUpdateFileParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the repo update file params
func (o *RepoUpdateFileParams) WithBody(body *models.UpdateFileOptions) *RepoUpdateFileParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the repo update file params
func (o *RepoUpdateFileParams) SetBody(body *models.UpdateFileOptions) {
	o.Body = body
}

// WithFilepath adds the filepath to the repo update file params
func (o *RepoUpdateFileParams) WithFilepath(filepath string) *RepoUpdateFileParams {
	o.SetFilepath(filepath)
	return o
}

// SetFilepath adds the filepath to the repo update file params
func (o *RepoUpdateFileParams) SetFilepath(filepath string) {
	o.Filepath = filepath
}

// WithOwner adds the owner to the repo update file params
func (o *RepoUpdateFileParams) WithOwner(owner string) *RepoUpdateFileParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo update file params
func (o *RepoUpdateFileParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo update file params
func (o *RepoUpdateFileParams) WithRepo(repo string) *RepoUpdateFileParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo update file params
func (o *RepoUpdateFileParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoUpdateFileParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param filepath
	if err := r.SetPathParam("filepath", o.Filepath); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
