// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewUpdateRepoSecretParams creates a new UpdateRepoSecretParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateRepoSecretParams() *UpdateRepoSecretParams {
	return &UpdateRepoSecretParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateRepoSecretParamsWithTimeout creates a new UpdateRepoSecretParams object
// with the ability to set a timeout on a request.
func NewUpdateRepoSecretParamsWithTimeout(timeout time.Duration) *UpdateRepoSecretParams {
	return &UpdateRepoSecretParams{
		timeout: timeout,
	}
}

// NewUpdateRepoSecretParamsWithContext creates a new UpdateRepoSecretParams object
// with the ability to set a context for a request.
func NewUpdateRepoSecretParamsWithContext(ctx context.Context) *UpdateRepoSecretParams {
	return &UpdateRepoSecretParams{
		Context: ctx,
	}
}

// NewUpdateRepoSecretParamsWithHTTPClient creates a new UpdateRepoSecretParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateRepoSecretParamsWithHTTPClient(client *http.Client) *UpdateRepoSecretParams {
	return &UpdateRepoSecretParams{
		HTTPClient: client,
	}
}

/*
UpdateRepoSecretParams contains all the parameters to send to the API endpoint

	for the update repo secret operation.

	Typically these are written to a http.Request.
*/
type UpdateRepoSecretParams struct {

	// Body.
	Body *models.CreateOrUpdateSecretOption

	/* Owner.

	   owner of the repository
	*/
	Owner string

	/* Repo.

	   name of the repository
	*/
	Repo string

	/* Secretname.

	   name of the secret
	*/
	Secretname string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update repo secret params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateRepoSecretParams) WithDefaults() *UpdateRepoSecretParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update repo secret params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateRepoSecretParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the update repo secret params
func (o *UpdateRepoSecretParams) WithTimeout(timeout time.Duration) *UpdateRepoSecretParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update repo secret params
func (o *UpdateRepoSecretParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update repo secret params
func (o *UpdateRepoSecretParams) WithContext(ctx context.Context) *UpdateRepoSecretParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update repo secret params
func (o *UpdateRepoSecretParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update repo secret params
func (o *UpdateRepoSecretParams) WithHTTPClient(client *http.Client) *UpdateRepoSecretParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update repo secret params
func (o *UpdateRepoSecretParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the update repo secret params
func (o *UpdateRepoSecretParams) WithBody(body *models.CreateOrUpdateSecretOption) *UpdateRepoSecretParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update repo secret params
func (o *UpdateRepoSecretParams) SetBody(body *models.CreateOrUpdateSecretOption) {
	o.Body = body
}

// WithOwner adds the owner to the update repo secret params
func (o *UpdateRepoSecretParams) WithOwner(owner string) *UpdateRepoSecretParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the update repo secret params
func (o *UpdateRepoSecretParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the update repo secret params
func (o *UpdateRepoSecretParams) WithRepo(repo string) *UpdateRepoSecretParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the update repo secret params
func (o *UpdateRepoSecretParams) SetRepo(repo string) {
	o.Repo = repo
}

// WithSecretname adds the secretname to the update repo secret params
func (o *UpdateRepoSecretParams) WithSecretname(secretname string) *UpdateRepoSecretParams {
	o.SetSecretname(secretname)
	return o
}

// SetSecretname adds the secretname to the update repo secret params
func (o *UpdateRepoSecretParams) SetSecretname(secretname string) {
	o.Secretname = secretname
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateRepoSecretParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	// path param secretname
	if err := r.SetPathParam("secretname", o.Secretname); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
