// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewUserCurrentCheckSubscriptionParams creates a new UserCurrentCheckSubscriptionParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUserCurrentCheckSubscriptionParams() *UserCurrentCheckSubscriptionParams {
	return &UserCurrentCheckSubscriptionParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUserCurrentCheckSubscriptionParamsWithTimeout creates a new UserCurrentCheckSubscriptionParams object
// with the ability to set a timeout on a request.
func NewUserCurrentCheckSubscriptionParamsWithTimeout(timeout time.Duration) *UserCurrentCheckSubscriptionParams {
	return &UserCurrentCheckSubscriptionParams{
		timeout: timeout,
	}
}

// NewUserCurrentCheckSubscriptionParamsWithContext creates a new UserCurrentCheckSubscriptionParams object
// with the ability to set a context for a request.
func NewUserCurrentCheckSubscriptionParamsWithContext(ctx context.Context) *UserCurrentCheckSubscriptionParams {
	return &UserCurrentCheckSubscriptionParams{
		Context: ctx,
	}
}

// NewUserCurrentCheckSubscriptionParamsWithHTTPClient creates a new UserCurrentCheckSubscriptionParams object
// with the ability to set a custom HTTPClient for a request.
func NewUserCurrentCheckSubscriptionParamsWithHTTPClient(client *http.Client) *UserCurrentCheckSubscriptionParams {
	return &UserCurrentCheckSubscriptionParams{
		HTTPClient: client,
	}
}

/*
UserCurrentCheckSubscriptionParams contains all the parameters to send to the API endpoint

	for the user current check subscription operation.

	Typically these are written to a http.Request.
*/
type UserCurrentCheckSubscriptionParams struct {

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the user current check subscription params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UserCurrentCheckSubscriptionParams) WithDefaults() *UserCurrentCheckSubscriptionParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the user current check subscription params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UserCurrentCheckSubscriptionParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the user current check subscription params
func (o *UserCurrentCheckSubscriptionParams) WithTimeout(timeout time.Duration) *UserCurrentCheckSubscriptionParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the user current check subscription params
func (o *UserCurrentCheckSubscriptionParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the user current check subscription params
func (o *UserCurrentCheckSubscriptionParams) WithContext(ctx context.Context) *UserCurrentCheckSubscriptionParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the user current check subscription params
func (o *UserCurrentCheckSubscriptionParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the user current check subscription params
func (o *UserCurrentCheckSubscriptionParams) WithHTTPClient(client *http.Client) *UserCurrentCheckSubscriptionParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the user current check subscription params
func (o *UserCurrentCheckSubscriptionParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOwner adds the owner to the user current check subscription params
func (o *UserCurrentCheckSubscriptionParams) WithOwner(owner string) *UserCurrentCheckSubscriptionParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the user current check subscription params
func (o *UserCurrentCheckSubscriptionParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the user current check subscription params
func (o *UserCurrentCheckSubscriptionParams) WithRepo(repo string) *UserCurrentCheckSubscriptionParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the user current check subscription params
func (o *UserCurrentCheckSubscriptionParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *UserCurrentCheckSubscriptionParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
