// Code generated by go-swagger; DO NOT EDIT.

package user

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewCreateUserVariableParams creates a new CreateUserVariableParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateUserVariableParams() *CreateUserVariableParams {
	return &CreateUserVariableParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateUserVariableParamsWithTimeout creates a new CreateUserVariableParams object
// with the ability to set a timeout on a request.
func NewCreateUserVariableParamsWithTimeout(timeout time.Duration) *CreateUserVariableParams {
	return &CreateUserVariableParams{
		timeout: timeout,
	}
}

// NewCreateUserVariableParamsWithContext creates a new CreateUserVariableParams object
// with the ability to set a context for a request.
func NewCreateUserVariableParamsWithContext(ctx context.Context) *CreateUserVariableParams {
	return &CreateUserVariableParams{
		Context: ctx,
	}
}

// NewCreateUserVariableParamsWithHTTPClient creates a new CreateUserVariableParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateUserVariableParamsWithHTTPClient(client *http.Client) *CreateUserVariableParams {
	return &CreateUserVariableParams{
		HTTPClient: client,
	}
}

/*
CreateUserVariableParams contains all the parameters to send to the API endpoint

	for the create user variable operation.

	Typically these are written to a http.Request.
*/
type CreateUserVariableParams struct {

	// Body.
	Body *models.CreateVariableOption

	/* Variablename.

	   name of the variable
	*/
	Variablename string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create user variable params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateUserVariableParams) WithDefaults() *CreateUserVariableParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create user variable params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateUserVariableParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create user variable params
func (o *CreateUserVariableParams) WithTimeout(timeout time.Duration) *CreateUserVariableParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create user variable params
func (o *CreateUserVariableParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create user variable params
func (o *CreateUserVariableParams) WithContext(ctx context.Context) *CreateUserVariableParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create user variable params
func (o *CreateUserVariableParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create user variable params
func (o *CreateUserVariableParams) WithHTTPClient(client *http.Client) *CreateUserVariableParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create user variable params
func (o *CreateUserVariableParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the create user variable params
func (o *CreateUserVariableParams) WithBody(body *models.CreateVariableOption) *CreateUserVariableParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the create user variable params
func (o *CreateUserVariableParams) SetBody(body *models.CreateVariableOption) {
	o.Body = body
}

// WithVariablename adds the variablename to the create user variable params
func (o *CreateUserVariableParams) WithVariablename(variablename string) *CreateUserVariableParams {
	o.SetVariablename(variablename)
	return o
}

// SetVariablename adds the variablename to the create user variable params
func (o *CreateUserVariableParams) SetVariablename(variablename string) {
	o.Variablename = variablename
}

// WriteToRequest writes these params to a swagger request
func (o *CreateUserVariableParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param variablename
	if err := r.SetPathParam("variablename", o.Variablename); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
