// Code generated by go-swagger; DO NOT EDIT.

package user

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewUserDeleteHookParams creates a new UserDeleteHookParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUserDeleteHookParams() *UserDeleteHookParams {
	return &UserDeleteHookParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUserDeleteHookParamsWithTimeout creates a new UserDeleteHookParams object
// with the ability to set a timeout on a request.
func NewUserDeleteHookParamsWithTimeout(timeout time.Duration) *UserDeleteHookParams {
	return &UserDeleteHookParams{
		timeout: timeout,
	}
}

// NewUserDeleteHookParamsWithContext creates a new UserDeleteHookParams object
// with the ability to set a context for a request.
func NewUserDeleteHookParamsWithContext(ctx context.Context) *UserDeleteHookParams {
	return &UserDeleteHookParams{
		Context: ctx,
	}
}

// NewUserDeleteHookParamsWithHTTPClient creates a new UserDeleteHookParams object
// with the ability to set a custom HTTPClient for a request.
func NewUserDeleteHookParamsWithHTTPClient(client *http.Client) *UserDeleteHookParams {
	return &UserDeleteHookParams{
		HTTPClient: client,
	}
}

/*
UserDeleteHookParams contains all the parameters to send to the API endpoint

	for the user delete hook operation.

	Typically these are written to a http.Request.
*/
type UserDeleteHookParams struct {

	/* ID.

	   id of the hook to delete

	   Format: int64
	*/
	ID int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the user delete hook params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UserDeleteHookParams) WithDefaults() *UserDeleteHookParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the user delete hook params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UserDeleteHookParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the user delete hook params
func (o *UserDeleteHookParams) WithTimeout(timeout time.Duration) *UserDeleteHookParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the user delete hook params
func (o *UserDeleteHookParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the user delete hook params
func (o *UserDeleteHookParams) WithContext(ctx context.Context) *UserDeleteHookParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the user delete hook params
func (o *UserDeleteHookParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the user delete hook params
func (o *UserDeleteHookParams) WithHTTPClient(client *http.Client) *UserDeleteHookParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the user delete hook params
func (o *UserDeleteHookParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the user delete hook params
func (o *UserDeleteHookParams) WithID(id int64) *UserDeleteHookParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the user delete hook params
func (o *UserDeleteHookParams) SetID(id int64) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *UserDeleteHookParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
